extensions[
 array
]

breed [cars car]
breed [ringcars ringcar]
breed [spawns spawn]
breed [clocks clock]
breed [pedess pedes]

globals[
  mapvariable
  stoppedcars stoppedcarsf stoppedcarsr;;/////////////////////////////////
  totalstoptime totalstoptimef totalstoptimer;;/////////////////////////////////
  timedriven timedrivenf timedrivenr;;/////////////////////////////////
  averagetimedriven
newringcar
  finishedcars finishedcarsf finishedcarsr;;/////////////////////////////////
  averagedistance
  averagecars
finishedtrafficlights finishedtrafficlightsf finishedtrafficlightsr;;/////////////////////////////////
 avspeed avspeedf avspeedr;;/////////////////////////////////
  stateTime
  systemLightStateList
  systemIntersectionList
  systemIntersectionCurrentStateList
  systemIntersectionActiveList
  systemIntersectionActiveTimeList
  I1 I2 I3 I4 I5 I6 I7 I8 I9 I10 I11 I12
  CAR_C
  PED_C
  CAR_T
  PED_T
  CAR_P
  PED_P
  golightnum
  forward% left%
  pedn pedw peds pede
  ecr ecf ecl cer cef cel
  ncr ncf ncl cnr cnf cnl
  wcr wcf wcl cwr cwf cwl
  scr scf scl csr csf csl
  clockNorth clockSouth
  costLightList carsLightList maxWaitingTimeLightList carsPatchList
  totaldistancedriven totaldistancedrivenf totaldistancedrivenr;;/////////////////////////////////
  pedesspawn
  randomped
  GLobleTime
  globleCostFuctionStateListIntersectoin0
  globleCostPerLightListIntersectoin0
  globleCarPerLightListIntersectoin0
  globleWinner
  maxspeedglobal
  avstopped avstoppedf avstoppedr
  avtstopped avtstoppedf avtstoppedr
  avtall avtallf avtallr
  averagefinish averagefinishf averagefinishr
  string
  spawnringcar
  ringxstopped ringtstopped ringfinish
]

spawns-own [
waittime
spawnlocation
spawneven
  strook
]

clocks-own[
 clockweight
]

cars-own[
destination
spawnlocation
stopped
  stoptime
speed
maxspeed
acceleration
deceleration
spawneven
directionhelper
direction
  distancedriven
  maxspeed1
  invoegen
  destinationindex
  strook
  tickss
  sumspeed
  turned
  avvspeed
]

ringcars-own[
  destination
spawnlocation
stopped
  stoptime
speed
maxspeed
acceleration
deceleration
spawneven
directionhelper
direction
  distancedriven
  maxspeed1
  invoegen
  destinationindex
  strook
  tickss
  sumspeed
  turned
  timesstopped
  ringstopped
  avvspeed
]

pedess-own[
 stoptime
]

to setup
  clear-all
  set mapvariable "map.png"
  set-default-shape pedess "circle 2"
    set-default-shape spawns "arrow"
   set-default-shape clocks "square"
  set-default-shape cars "car top"
  import-pcolors mapvariable
  setup-spawns
  set pedesspawn 0
  set maxspeedglobal 0.7
  notes
  setupLight
  set avspeed [0]
  set avspeedf [0]
  set avspeedr [0]
  set ringxstopped [0] set ringtstopped [0] set ringfinish  [0]
  spawnclock
  ifelse(realdistribution)[set forward%  59 set left% 75][set forward% 40 set left% 70]
  reset-ticks
end

to spawn-ringcar
  ask patches with[pcolor = 120][sprout-ringcars 1[
    set color yellow

       set heading 90
    fd 1
       set direction "FFFFFFFFFFFF"
       set directionhelper 1
          set maxspeed maxspeedglobal
          set maxspeed1 maxspeedglobal
          set acceleration 0.1
          set deceleration 0.2
          set destinationindex 0
          set speed maxspeed
          set newringcar turtle who
  ]]
  watch newringcar
  inspect newringcar
end
to spawn-ringcars

  ask patches with[pcolor = 120][if(not any? turtles-here) [sprout-ringcars 1[
    set color yellow

       set heading 90
    fd 1
       set direction "FFFFFFFFFFFF"
       set directionhelper 1
          set maxspeed maxspeedglobal
          set maxspeed1 maxspeedglobal
          set acceleration 0.1
          set deceleration 0.2
          set destinationindex 0
          set speed maxspeed
  ] set spawnringcar 0]
    ]
end

to go
  if (ticks < runfor)[
    if(SpawnPercentage != 0)[
      spawn-cars]
    goligth
    if(stoppedcars != 0)[set avtstopped totalstoptime / stoppedcars]
    if(stoppedcarsf != 0)[set avtstoppedf totalstoptimef / stoppedcarsf]
    if(stoppedcarsr != 0)[set avtstoppedr totalstoptimer / stoppedcarsr]
    if(finishedcars != 0)[set avtall totalstoptime / finishedcars
    set averagefinish timedriven / finishedcars]
    if(finishedcarsf != 0)[set avtallf totalstoptimef / finishedcarsf
    set averagefinishf timedrivenf / finishedcarsf]
    if(finishedcarsr != 0)[set avtallr totalstoptimer / finishedcarsr
    set averagefinishr timedrivenr / finishedcarsr
    set avstoppedr (stoppedcarsr / finishedcarsr )]
    if(averagecars != 0)[set avstopped (stoppedcars / (finishedcars + averagecars))
      set avstoppedf (stoppedcarsf / (finishedcarsf + averagecars))]


if((ticks mod 1000 = 0 AND ticks != 0) OR spawnringcar = 1)
    [
      set spawnringcar 1
      spawn-ringcars
    ]

    ask cars[move-cars]
    ask ringcars[
        move-cars
        if(pcolor = 120)[;dood
        set finishedcarsr finishedcarsr + 1

        ifelse (avspeed != [0])[set avspeed lput avvspeed avspeed][set avspeed replace-item 0 avspeed avvspeed]
        ifelse (avspeedf != [0])[set avspeedf lput avvspeed avspeedf][set avspeedf replace-item 0 avspeedf avvspeed]
        ifelse (avspeedr != [0])[set avspeedr lput avvspeed avspeedr][set avspeedr replace-item 0 avspeedr avvspeed]
        set timedrivenr timedrivenr + tickss
        set totaldistancedrivenr totaldistancedrivenr + distancedriven
        ifelse (ringtstopped != [0])[set ringtstopped lput ringstopped ringtstopped][set ringtstopped replace-item 0 ringtstopped ringstopped]
        ifelse (ringxstopped != [0])[set ringxstopped lput timesstopped ringxstopped][set ringxstopped replace-item 0 ringxstopped timesstopped]
        ifelse (ringfinish != [0])[set ringfinish lput tickss ringfinish][set ringfinish replace-item 0 ringfinish tickss]


        die
    ]]
  set averagecars count cars
  moveclock
    pedspawn
    ask pedess [ if(pcolor = 53)[die]
      set stoptime stoptime + 1]
    if(ticks mod 10 = 0) [printoutput]
    tick]
end

to setup-spawns
  ask patches with [pcolor = blue and not any? other turtles-here][sprout-spawns 1[set color red set waittime random 30]]
  ask spawns[
    set heading 0
    if ([pcolor] of patch-at-heading-and-distance -90 1 = red ) [set heading 90]
    if ([pcolor] of patch-at-heading-and-distance 0 1 = red )  [set heading 180]
    if ([pcolor] of patch-at-heading-and-distance -180 1 = red ) [set heading 0]
    if ([pcolor] of patch-at-heading-and-distance 90 1 = red ) [set heading 270]
    ifelse(xcor = 141 OR xcor = 141 + 1 * 281 OR xcor = 141 + 2 * 281 OR xcor = 141 + 3 * 281 OR xcor = 141 + 4 * 281 OR xcor = 141 + 5 * 281 OR xcor = 141 + 6 * 281 OR xcor = 141 + 7 * 281 OR xcor = 141 + 8 * 281 OR xcor = 141 + 9 * 281 OR xcor = 141 + 10 * 281 OR xcor = 141 + 11 * 281 OR xcor = 141 + 12 * 281 OR xcor = 141 + 13 * 281 OR xcor = 141 + 14 * 281 OR xcor = 141 + 15 * 281 OR xcor = 141 + 16 * 281 OR xcor = 141 + 17 * 281 OR xcor = 141 + 18 * 281 OR xcor = 141 + 19 * 281 OR xcor = 141 + 20 * 281 OR xcor = 141 + 21 * 281 OR xcor = 141 + 22 * 281 OR xcor = 141 + 23 * 281 OR xcor = 141 + 24 * 281
        OR xcor = 139 OR xcor = 139 + 1 * 281 OR xcor = 139 + 2 * 281 OR xcor = 139 + 3 * 281 OR xcor = 139 + 4 * 281 OR xcor = 139 + 5 * 281 OR xcor = 139 + 6 * 281 OR xcor = 139 + 7 * 281 OR xcor = 139 + 8 * 281 OR xcor = 139 + 9 * 281 OR xcor = 139 + 10 * 281 OR xcor = 139 + 11 * 281 OR xcor = 139 + 12 * 281 OR xcor = 139 + 13 * 281 OR xcor = 139 + 14 * 281 OR xcor = 139 + 15 * 281 OR xcor = 139 + 16 * 281 OR xcor = 139 + 17 * 281 OR xcor = 139 + 18 * 281 OR xcor = 139 + 19 * 281 OR xcor = 139 + 20 * 281 OR xcor = 139 + 21 * 281 OR xcor = 139 + 22 * 281 OR xcor = 139 + 23 * 281 OR xcor = 139 + 24 * 281 )[
    set strook  1
    ][
    set strook  0
    ]
    ]
end

to spawn-cars
  ask spawns[
   if (waittime = 0 AND not any? turtles-on patch-ahead 1 AND not any? turtles-on patch-ahead 2 AND not any? cars-here)[

     hatch-cars 1[ set color sky

       fd 1
        destinations
        set direction directions
        set directionhelper 1
        set maxspeed maxspeedglobal
        set maxspeed1 maxspeedglobal
        set acceleration 0.1
        set deceleration 0.2
        set destinationindex 0
        set speed maxspeed
     ]


   set waittime 135 - SpawnPercentage + random 10
    ]
  if(waittime != 0)
    [
      set waittime waittime - 1
    ]
  ]
end

to pedspawn
  ifelse(pedesspawn = ticks)[
     set randomped random 4
    if (randomped = 0)[ ask one-of array:item pedn random 12[sprout-pedess 1[set color 135 ]] ]
    if (randomped = 1)[ ask one-of array:item pedw random 12[sprout-pedess 1[set color 135 ]] ]
    if (randomped = 2)[ ask one-of array:item pede random 12[sprout-pedess 1[set color 135 ]] ]
    if (randomped = 3)[ ask one-of array:item peds random 12[sprout-pedess 1[set color 135 ]] ]
  ][set pedesspawn pedesspawn + 2]
end

to moveclock
  ask clocks[
    fd clockspeed
  ]
end

to spawnclock
  ask patches with [ pcolor = 16 and not any? other turtles-here] [sprout-clocks 1]

  ask clocks [ set color grey
    set clockweight 1
    ifelse(ycor = 0)[set heading -90][set heading 90]
  if(AmountOfClocks != 0)[
    let xx 0
  let i 0
    while [i < AmountOfClocks][
    if ((xcor = 0 + xx)OR( xcor = 75 + xx))[set clockweight tau 1 set color  49.4]
    if ((xcor = 1 + xx)OR( xcor = 74 + xx))[set clockweight tau 2 set color  49.2]
    if ((xcor = 2 + xx)OR( xcor = 73 + xx))[set clockweight tau 3 set color  49]
    if ((xcor = 3 + xx)OR( xcor = 72 + xx))[set clockweight tau 4 set color  48.8]
    if ((xcor = 4 + xx)OR( xcor = 71 + xx))[set clockweight tau 5 set color  48.6]
    if ((xcor = 5 + xx)OR( xcor = 70 + xx))[set clockweight tau 6 set color  48.4]
    if ((xcor = 6 + xx)OR( xcor = 69 + xx))[set clockweight tau 7 set color  48.2]
    if ((xcor = 7 + xx)OR( xcor = 68 + xx))[set clockweight tau 8 set color  48]
    if ((xcor = 8 + xx)OR( xcor = 67 + xx))[set clockweight tau 9 set color  47.8]
    if ((xcor = 9 + xx)OR( xcor = 66 + xx))[set clockweight tau 10 set color  47.6]
    if ((xcor = 10 + xx)OR( xcor = 65 + xx))[set clockweight tau 11 set color  47.4]
    if ((xcor = 11 + xx)OR( xcor = 64 + xx))[set clockweight tau 12 set color  47.2]
    if ((xcor = 12 + xx)OR( xcor = 63 + xx))[set clockweight tau 13 set color  47]
    if ((xcor = 13 + xx)OR( xcor = 62 + xx))[set clockweight tau 14 set color  46.8]
    if ((xcor = 14 + xx)OR( xcor = 61 + xx))[set clockweight tau 15 set color  46.6]
    if ((xcor = 15 + xx)OR( xcor = 60 + xx))[set clockweight tau 16 set color  46.4]
    if ((xcor = 16 + xx)OR( xcor = 59 + xx))[set clockweight tau 17 set color  46.2]
    if ((xcor = 17 + xx)OR( xcor = 58 + xx))[set clockweight tau 18 set color  46]
    if ((xcor = 18 + xx)OR( xcor = 57 + xx))[set clockweight tau 19 set color  45.8]
    if ((xcor = 19 + xx)OR( xcor = 56 + xx))[set clockweight tau 20 set color  45.6]
    if ((xcor = 20 + xx)OR( xcor = 55 + xx))[set clockweight tau 21 set color  45.4]
    if ((xcor = 21 + xx)OR( xcor = 54 + xx))[set clockweight tau 22 set color  45.2]
    if ((xcor = 22 + xx)OR( xcor = 53 + xx))[set clockweight tau 23 set color  45]
    if ((xcor = 23 + xx)OR( xcor = 52 + xx))[set clockweight tau 24 set color  44.8]
    if ((xcor = 24 + xx)OR( xcor = 51 + xx))[set clockweight tau 25 set color  44.6]
    if ((xcor = 25 + xx)OR( xcor = 50 + xx))[set clockweight tau 26 set color  44.4]
    if ((xcor = 26 + xx)OR( xcor = 49 + xx))[set clockweight tau 27 set color  44.2]
    if ((xcor = 27 + xx)OR( xcor = 48 + xx))[set clockweight tau 28 set color  44]
    if ((xcor = 28 + xx)OR( xcor = 47 + xx))[set clockweight tau 29 set color  43.8]
    if ((xcor = 29 + xx)OR( xcor = 46 + xx))[set clockweight tau 30 set color  43.6]
    if ((xcor = 30 + xx)OR( xcor = 45 + xx))[set clockweight tau 31 set color  43.4]
    if ((xcor = 31 + xx)OR( xcor = 44 + xx))[set clockweight tau 32 set color  43.2]
    if ((xcor = 32 + xx)OR( xcor = 43 + xx))[set clockweight tau 33 set color  43]
    if ((xcor = 33 + xx)OR( xcor = 42 + xx))[set clockweight tau 34 set color  42.8]
    if ((xcor = 34 + xx)OR( xcor = 41 + xx))[set clockweight tau 35 set color  42.6]
    if ((xcor = 35 + xx)OR( xcor = 40 + xx))[set clockweight tau 36 set color  42.4]
    if ((xcor = 36 + xx)OR( xcor = 39 + xx))[set clockweight tau 37 set color  42.2]
    if ((xcor = 37 + xx)OR( xcor = 38 + xx))[set clockweight tau 38 set color  42]

      set i i + 1
      set xx xx + round(((3372 - 75 * AmountOfClocks) / AmountOfClocks)) + 75
      ]
    ]

  ]
end

to-report tau [number]
  report clockPower  + ((0.5 * clockPower) * number)/(38)
end

to notes
  let i 0
  while [i != 24][

  ask spawns with [(xcor = 141 + i * 281 OR xcor = 142 + i * 281) AND ycor = 4][
    set spawnlocation  i * 2 + 1
    set spawneven 0
  ]
  ask spawns with [(xcor = 138 + i * 281 OR xcor = 139 + i * 281) AND ycor = 110][
    set spawnlocation i * 2 + 2
    set spawneven 1
  ]
  set i i + 1
  ]
end
;///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
;traffic light
;///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
to setupLight
  setupCoordinatenLigthsArrays
  setupLigthStates ;deze moet aan het begin worden gerund
  setupIntersections ;deze moet aan het begin worden gerund
  setupCostFunction;
  print "Setup Compleet"
  set stateTime 5 ; Set the time between states
end

to setupCoordinatenLigthsArrays
  ;"(pycor = 61 AND (pxcor = x + 3 OR pxcor = x - 4))";boven pedestrian
  ;"(pxcor = x - 4 AND (pycor = 60 OR pycor = 53))";links pedestrian
  ;"(pycor = 53 AND (pxcor = x -3 OR pxcor = x + 4))";onder pedestrian
  ; "(pxcor = x + 4 AND (pycor = 54 OR pycor = 61))";rechts pedestrian
  set pedn array:from-list n-values 24 [0]
  set pedw array:from-list n-values 24 [0]
  set peds array:from-list n-values 24 [0]
  set pede array:from-list n-values 24 [0]
  set ecr array:from-list n-values 24 [0]
  set ecf array:from-list n-values 24 [0]
  set ecl array:from-list n-values 24 [0]
  set ncr array:from-list n-values 24 [0]
  set ncf array:from-list n-values 24 [0]
  set ncl array:from-list n-values 24 [0]
  set wcr array:from-list n-values 24 [0]
  set wcf array:from-list n-values 24 [0]
  set wcl array:from-list n-values 24 [0]
  set scr array:from-list n-values 24 [0]
  set scf array:from-list n-values 24 [0]
  set scl array:from-list n-values 24 [0]
  set cnr array:from-list n-values 24 [0]
  set cnf array:from-list n-values 24 [0]
  set cnl array:from-list n-values 24 [0]
  set cwr array:from-list n-values 24 [0]
  set cwf array:from-list n-values 24 [0]
  set cwl array:from-list n-values 24 [0]
  set csr array:from-list n-values 24 [0]
  set csf array:from-list n-values 24 [0]
  set csl array:from-list n-values 24 [0]
  set cer array:from-list n-values 24 [0]
  set cef array:from-list n-values 24 [0]
  set cel array:from-list n-values 24 [0]
  set clockNorth array:from-list n-values 12 [0]
  set clockSouth array:from-list n-values 12 [0]

  let x 140 + 281 * 0
  array:set pedn 0 patches with [pycor = 61  AND (pxcor = x + 3 OR pxcor = x - 4)]
  array:set pedw 0 patches with [pxcor = x - 4 AND (pycor = 60 OR pycor = 53)]
  array:set peds 0 patches with [pycor = 53 AND (pxcor = x - 3 OR pxcor = x + 4)]
  array:set pede 0 patches with [pxcor = x + 4 AND (pycor = 54 OR pycor = 61)]
  array:set ecr  0 patches with [(pxcor = x + 3 OR pxcor = x + 4)AND pycor = 60]
  array:set ecf  0 patches with [(pxcor = x + 3 OR pxcor = x + 4)AND ( pycor = 58 OR pycor = 59)]
  array:set ecl  0 patches with [(pxcor = x + 3 OR pxcor = x + 4)AND pycor = 57]
  array:set ncr  0 patches with [(pycor = 60 OR pycor = 61) AND pxcor = x - 3]
  array:set ncf  0 patches with [(pycor = 60 OR pycor = 61) AND ( pxcor = x - 2 OR pxcor = x - 1)]
  array:set ncl  0 patches with [(pycor = 60 OR pycor = 61) AND pxcor = x]
  array:set wcr  0 patches with [(pxcor = x - 3 OR pxcor = x - 4) AND pycor = 54]
  array:set wcf  0 patches with [(pxcor = x - 3 OR pxcor = x - 4) AND (pycor = 55 OR pycor = 56)]
  array:set wcl  0 patches with [(pxcor = x - 3 OR pxcor = x - 4) AND pycor = 57]
  array:set scr  0 patches with [(pycor = 54 OR pycor = 53) AND pxcor = x + 3]
  array:set scf  0 patches with [(pycor = 54 OR pycor = 53) AND (pxcor = x + 2 OR pxcor = x + 1)]
  array:set scl  0 patches with [(pycor = 54 OR pycor = 53) AND pxcor = x]

  array:set cnr 0 patches with [pycor > 60 AND pycor < 98 AND pxcor = x - 3]
  array:set cnf 0 patches with [pycor > 60 AND pycor < 98 AND (pxcor = x - 2 OR pxcor = x - 1)]
  array:set cnl 0 patches with [pycor > 60 AND pycor < 98 AND pxcor = x]
  array:set cer 0 patches with [pxcor > x + 3 AND pxcor < x + 41 AND pycor = 60]
  array:set cef 0 patches with [pxcor > x + 3 AND pxcor < x + 41 AND (pycor = 58 OR pycor = 59)]
  array:set cel 0 patches with [pxcor > x + 3 AND pxcor < x + 41 AND pycor = 57]
  array:set csr 0 patches with [pycor > 16 AND pycor < 54 AND pxcor = x + 3]
  array:set csf 0 patches with [pycor > 16 AND pycor < 54 AND (pxcor = x + 1 OR pxcor = x + 2)]
  array:set csl 0 patches with [pycor > 16 AND pycor < 54 AND pxcor = x]
  array:set cwr 0 patches with [pxcor < x - 3 AND pxcor > x - 41 AND pycor = 54]
  array:set cwf 0 patches with [pxcor < x - 3 AND pxcor > x - 41 AND (pycor = 55 OR pycor = 56)]
  array:set cwl 0 patches with [pxcor < x - 3 AND pxcor > x - 41 AND pycor = 57]

  array:set clockNorth 0 patches with [pxcor = x AND pycor = 114]
  array:set clockSouth 0 patches with [pxcor = x AND pycor = 0]

  set x 140 + 281 * 1
  array:set pedn 1 patches with [pycor = 61  AND (pxcor = x + 3 OR pxcor = x - 4)]
  array:set pedw 1 patches with [pxcor = x - 4 AND (pycor = 60 OR pycor = 53)]
  array:set peds 1 patches with [pycor = 53 AND (pxcor = x - 3 OR pxcor = x + 4)]
  array:set pede 1 patches with [pxcor = x + 4 AND (pycor = 54 OR pycor = 61)]
  array:set ecr  1 patches with [(pxcor = x + 3 OR pxcor = x + 4)AND pycor = 60]
  array:set ecf  1 patches with [(pxcor = x + 3 OR pxcor = x + 4)AND ( pycor = 58 OR pycor = 59)]
  array:set ecl  1 patches with [(pxcor = x + 3 OR pxcor = x + 4)AND pycor = 57]
  array:set ncr  1 patches with [(pycor = 60 OR pycor = 61) AND pxcor = x - 3]
  array:set ncf  1 patches with [(pycor = 60 OR pycor = 61) AND ( pxcor = x - 2 OR pxcor = x - 1)]
  array:set ncl  1 patches with [(pycor = 60 OR pycor = 61) AND pxcor = x]
  array:set wcr  1 patches with [(pxcor = x - 3 OR pxcor = x - 4) AND pycor = 54]
  array:set wcf  1 patches with [(pxcor = x - 3 OR pxcor = x - 4) AND (pycor = 55 OR pycor = 56)]
  array:set wcl  1 patches with [(pxcor = x - 3 OR pxcor = x - 4) AND pycor = 57]
  array:set scr  1 patches with [(pycor = 54 OR pycor = 53) AND pxcor = x + 3]
  array:set scf  1 patches with [(pycor = 54 OR pycor = 53) AND (pxcor = x + 2 OR pxcor = x + 1)]
  array:set scl  1 patches with [(pycor = 54 OR pycor = 53) AND pxcor = x]

  array:set cnr 1 patches with [pycor > 60 AND pycor < 98 AND pxcor = x - 3]
  array:set cnf 1 patches with [pycor > 60 AND pycor < 98 AND (pxcor = x - 2 OR pxcor = x - 1)]
  array:set cnl 1 patches with [pycor > 60 AND pycor < 98 AND pxcor = x]
  array:set cer 1 patches with [pxcor > x + 3 AND pxcor < x + 41 AND pycor = 60]
  array:set cef 1 patches with [pxcor > x + 3 AND pxcor < x + 41 AND (pycor = 58 OR pycor = 59)]
  array:set cel 1 patches with [pxcor > x + 3 AND pxcor < x + 41 AND pycor = 57]
  array:set csr 1 patches with [pycor > 16 AND pycor < 54 AND pxcor = x + 3]
  array:set csf 1 patches with [pycor > 16 AND pycor < 54 AND (pxcor = x + 1 OR pxcor = x + 2)]
  array:set csl 1 patches with [pycor > 16 AND pycor < 54 AND pxcor = x]
  array:set cwr 1 patches with [pxcor < x - 3 AND pxcor > x - 41 AND pycor = 54]
  array:set cwf 1 patches with [pxcor < x - 3 AND pxcor > x - 41 AND (pycor = 55 OR pycor = 56)]
  array:set cwl 1 patches with [pxcor < x - 3 AND pxcor > x - 41 AND pycor = 57]

  array:set clockNorth 1 patches with [pxcor = x AND pycor = 114]
  array:set clockSouth 1 patches with [pxcor = x AND pycor = 0]

  set x 140 + 281 * 2
  array:set pedn 2 patches with [pycor = 61 AND (pxcor = x + 3 OR pxcor = x - 4)]
  array:set pedw 2 patches with [pxcor = x - 4 AND (pycor = 60 OR pycor = 53)]
  array:set peds 2 patches with [pycor = 53 AND (pxcor = x - 3 OR pxcor = x + 4)]
  array:set pede 2 patches with [pxcor = x + 4 AND (pycor = 54 OR pycor = 61)]
  array:set ecr  2 patches with [(pxcor = x + 3 OR pxcor = x + 4)AND pycor = 60]
  array:set ecf  2 patches with [(pxcor = x + 3 OR pxcor = x + 4)AND ( pycor = 58 OR pycor = 59)]
  array:set ecl  2 patches with [(pxcor = x + 3 OR pxcor = x + 4)AND pycor = 57]
  array:set ncr  2 patches with [(pycor = 60 OR pycor = 61) AND pxcor = x - 3]
  array:set ncf  2 patches with [(pycor = 60 OR pycor = 61) AND ( pxcor = x - 2 OR pxcor = x - 1)]
  array:set ncl  2 patches with [(pycor = 60 OR pycor = 61) AND pxcor = x]
  array:set wcr  2 patches with [(pxcor = x - 3 OR pxcor = x - 4) AND pycor = 54]
  array:set wcf  2 patches with [(pxcor = x - 3 OR pxcor = x - 4) AND (pycor = 55 OR pycor = 56)]
  array:set wcl  2 patches with [(pxcor = x - 3 OR pxcor = x - 4) AND pycor = 57]
  array:set scr  2 patches with [(pycor = 54 OR pycor = 53) AND pxcor = x + 3]
  array:set scf  2 patches with [(pycor = 54 OR pycor = 53) AND (pxcor = x + 2 OR pxcor = x + 1)]
  array:set scl  2 patches with [(pycor = 54 OR pycor = 53) AND pxcor = x]

  array:set cnr 2 patches with [pycor > 60 AND pycor < 98 AND pxcor = x - 3]
  array:set cnf 2 patches with [pycor > 60 AND pycor < 98 AND (pxcor = x - 2 OR pxcor = x - 1)]
  array:set cnl 2 patches with [pycor > 60 AND pycor < 98 AND pxcor = x]
  array:set cer 2 patches with [pxcor > x + 3 AND pxcor < x + 41 AND pycor = 60]
  array:set cef 2 patches with [pxcor > x + 3 AND pxcor < x + 41 AND (pycor = 58 OR pycor = 59)]
  array:set cel 2 patches with [pxcor > x + 3 AND pxcor < x + 41 AND pycor = 57]
  array:set csr 2 patches with [pycor > 16 AND pycor < 54 AND pxcor = x + 3]
  array:set csf 2 patches with [pycor > 16 AND pycor < 54 AND (pxcor = x + 1 OR pxcor = x + 2)]
  array:set csl 2 patches with [pycor > 16 AND pycor < 54 AND pxcor = x]
  array:set cwr 2 patches with [pxcor < x - 3 AND pxcor > x - 41 AND pycor = 54]
  array:set cwf 2 patches with [pxcor < x - 3 AND pxcor > x - 41 AND (pycor = 55 OR pycor = 56)]
  array:set cwl 2 patches with [pxcor < x - 3 AND pxcor > x - 41 AND pycor = 57]

  array:set clockNorth 2 patches with [pxcor = x AND pycor = 114]
  array:set clockSouth 2 patches with [pxcor = x AND pycor = 0]

  set x 140 + 281 * 3
  array:set pedn 3 patches with [pycor = 61 AND (pxcor = x + 3 OR pxcor = x - 4)]
  array:set pedw 3 patches with [pxcor = x - 4 AND (pycor = 60 OR pycor = 53)]
  array:set peds 3 patches with [pycor = 53 AND (pxcor = x - 3 OR pxcor = x + 4)]
  array:set pede 3 patches with [pxcor = x + 4 AND (pycor = 54 OR pycor = 61)]
  array:set ecr  3 patches with [(pxcor = x + 3 OR pxcor = x + 4)AND pycor = 60]
  array:set ecf  3 patches with [(pxcor = x + 3 OR pxcor = x + 4)AND ( pycor = 58 OR pycor = 59)]
  array:set ecl  3 patches with [(pxcor = x + 3 OR pxcor = x + 4)AND pycor = 57]
  array:set ncr  3 patches with [(pycor = 60 OR pycor = 61) AND pxcor = x - 3]
  array:set ncf  3 patches with [(pycor = 60 OR pycor = 61) AND ( pxcor = x - 2 OR pxcor = x - 1)]
  array:set ncl  3 patches with [(pycor = 60 OR pycor = 61) AND pxcor = x]
  array:set wcr  3 patches with [(pxcor = x - 3 OR pxcor = x - 4) AND pycor = 54]
  array:set wcf  3 patches with [(pxcor = x - 3 OR pxcor = x - 4) AND (pycor = 55 OR pycor = 56)]
  array:set wcl  3 patches with [(pxcor = x - 3 OR pxcor = x - 4) AND pycor = 57]
  array:set scr  3 patches with [(pycor = 54 OR pycor = 53) AND pxcor = x + 3]
  array:set scf  3 patches with [(pycor = 54 OR pycor = 53) AND (pxcor = x + 2 OR pxcor = x + 1)]
  array:set scl  3 patches with [(pycor = 54 OR pycor = 53) AND pxcor = x]

  array:set cnr 3 patches with [pycor > 60 AND pycor < 98 AND pxcor = x - 3]
  array:set cnf 3 patches with [pycor > 60 AND pycor < 98 AND (pxcor = x - 2 OR pxcor = x - 1)]
  array:set cnl 3 patches with [pycor > 60 AND pycor < 98 AND pxcor = x]
  array:set cer 3 patches with [pxcor > x + 3 AND pxcor < x + 41 AND pycor = 60]
  array:set cef 3 patches with [pxcor > x + 3 AND pxcor < x + 41 AND (pycor = 58 OR pycor = 59)]
  array:set cel 3 patches with [pxcor > x + 3 AND pxcor < x + 41 AND pycor = 57]
  array:set csr 3 patches with [pycor > 16 AND pycor < 54 AND pxcor = x + 3]
  array:set csf 3 patches with [pycor > 16 AND pycor < 54 AND (pxcor = x + 1 OR pxcor = x + 2)]
  array:set csl 3 patches with [pycor > 16 AND pycor < 54 AND pxcor = x]
  array:set cwr 3 patches with [pxcor < x - 3 AND pxcor > x - 41 AND pycor = 54]
  array:set cwf 3 patches with [pxcor < x - 3 AND pxcor > x - 41 AND (pycor = 55 OR pycor = 56)]
  array:set cwl 3 patches with [pxcor < x - 3 AND pxcor > x - 41 AND pycor = 57]

  array:set clockNorth 3 patches with [pxcor = x AND pycor = 114]
  array:set clockSouth 3 patches with [pxcor = x AND pycor = 0]

  set x 140 + 281 * 4
  array:set pedn 4  patches with [pycor = 61  AND (pxcor = x + 3 OR pxcor = x - 4)]
  array:set pedw 4  patches with [pxcor = x - 4 AND (pycor = 60 OR pycor = 53)]
  array:set peds 4  patches with [pycor = 53 AND (pxcor = x - 3 OR pxcor = x + 4)]
  array:set pede 4  patches with [pxcor = x + 4 AND (pycor = 54 OR pycor = 61)]
  array:set ecr  4  patches with [(pxcor = x + 3 OR pxcor = x + 4)AND pycor = 60]
  array:set ecf  4  patches with [(pxcor = x + 3 OR pxcor = x + 4)AND ( pycor = 58 OR pycor = 59)]
  array:set ecl  4  patches with [(pxcor = x + 3 OR pxcor = x + 4)AND pycor = 57]
  array:set ncr  4  patches with [(pycor = 60 OR pycor = 61) AND pxcor = x - 3]
  array:set ncf  4  patches with [(pycor = 60 OR pycor = 61) AND ( pxcor = x - 2 OR pxcor = x - 1)]
  array:set ncl  4  patches with [(pycor = 60 OR pycor = 61) AND pxcor = x]
  array:set wcr  4  patches with [(pxcor = x - 3 OR pxcor = x - 4) AND pycor = 54]
  array:set wcf  4  patches with [(pxcor = x - 3 OR pxcor = x - 4) AND (pycor = 55 OR pycor = 56)]
  array:set wcl  4  patches with [(pxcor = x - 3 OR pxcor = x - 4) AND pycor = 57]
  array:set scr  4  patches with [(pycor = 54 OR pycor = 53) AND pxcor = x + 3]
  array:set scf  4  patches with [(pycor = 54 OR pycor = 53) AND (pxcor = x + 2 OR pxcor = x + 1)]
  array:set scl  4  patches with [(pycor = 54 OR pycor = 53) AND pxcor = x]

  array:set cnr 4 patches with [pycor > 60 AND pycor < 98 AND pxcor = x - 3]
  array:set cnf 4 patches with [pycor > 60 AND pycor < 98 AND (pxcor = x - 2 OR pxcor = x - 1)]
  array:set cnl 4 patches with [pycor > 60 AND pycor < 98 AND pxcor = x]
  array:set cer 4 patches with [pxcor > x + 3 AND pxcor < x + 41 AND pycor = 60]
  array:set cef 4 patches with [pxcor > x + 3 AND pxcor < x + 41 AND (pycor = 58 OR pycor = 59)]
  array:set cel 4 patches with [pxcor > x + 3 AND pxcor < x + 41 AND pycor = 57]
  array:set csr 4 patches with [pycor > 16 AND pycor < 54 AND pxcor = x + 3]
  array:set csf 4 patches with [pycor > 16 AND pycor < 54 AND (pxcor = x + 1 OR pxcor = x + 2)]
  array:set csl 4 patches with [pycor > 16 AND pycor < 54 AND pxcor = x]
  array:set cwr 4 patches with [pxcor < x - 3 AND pxcor > x - 41 AND pycor = 54]
  array:set cwf 4 patches with [pxcor < x - 3 AND pxcor > x - 41 AND (pycor = 55 OR pycor = 56)]
  array:set cwl 4 patches with [pxcor < x - 3 AND pxcor > x - 41 AND pycor = 57]

  array:set clockNorth 4 patches with [pxcor = x AND pycor = 114]
  array:set clockSouth 4 patches with [pxcor = x AND pycor = 0]

  set x 140 + 281 * 5
  array:set pedn 5 patches with [pycor = 61  AND (pxcor = x + 3 OR pxcor = x - 4)]
  array:set pedw 5 patches with [pxcor = x - 4 AND (pycor = 60 OR pycor = 53)]
  array:set peds 5 patches with [pycor = 53 AND (pxcor = x - 3 OR pxcor = x + 4)]
  array:set pede 5 patches with [pxcor = x + 4 AND (pycor = 54 OR pycor = 61)]
  array:set ecr  5 patches with [(pxcor = x + 3 OR pxcor = x + 4)AND pycor = 60]
  array:set ecf  5 patches with [(pxcor = x + 3 OR pxcor = x + 4)AND ( pycor = 58 OR pycor = 59)]
  array:set ecl  5 patches with [(pxcor = x + 3 OR pxcor = x + 4)AND pycor = 57]
  array:set ncr  5 patches with [(pycor = 60 OR pycor = 61) AND pxcor = x - 3]
  array:set ncf  5 patches with [(pycor = 60 OR pycor = 61) AND ( pxcor = x - 2 OR pxcor = x - 1)]
  array:set ncl  5 patches with [(pycor = 60 OR pycor = 61) AND pxcor = x]
  array:set wcr  5 patches with [(pxcor = x - 3 OR pxcor = x - 4) AND pycor = 54]
  array:set wcf  5 patches with [(pxcor = x - 3 OR pxcor = x - 4) AND (pycor = 55 OR pycor = 56)]
  array:set wcl  5 patches with [(pxcor = x - 3 OR pxcor = x - 4) AND pycor = 57]
  array:set scr  5 patches with [(pycor = 54 OR pycor = 53) AND pxcor = x + 3]
  array:set scf  5 patches with [(pycor = 54 OR pycor = 53) AND (pxcor = x + 2 OR pxcor = x + 1)]
  array:set scl  5 patches with [(pycor = 54 OR pycor = 53) AND pxcor = x]

  array:set cnr 5 patches with [pycor > 60 AND pycor < 98 AND pxcor = x - 3]
  array:set cnf 5 patches with [pycor > 60 AND pycor < 98 AND (pxcor = x - 2 OR pxcor = x - 1)]
  array:set cnl 5 patches with [pycor > 60 AND pycor < 98 AND pxcor = x]
  array:set cer 5 patches with [pxcor > x + 3 AND pxcor < x + 41 AND pycor = 60]
  array:set cef 5 patches with [pxcor > x + 3 AND pxcor < x + 41 AND (pycor = 58 OR pycor = 59)]
  array:set cel 5 patches with [pxcor > x + 3 AND pxcor < x + 41 AND pycor = 57]
  array:set csr 5 patches with [pycor > 16 AND pycor < 54 AND pxcor = x + 3]
  array:set csf 5 patches with [pycor > 16 AND pycor < 54 AND (pxcor = x + 1 OR pxcor = x + 2)]
  array:set csl 5 patches with [pycor > 16 AND pycor < 54 AND pxcor = x]
  array:set cwr 5 patches with [pxcor < x - 3 AND pxcor > x - 41 AND pycor = 54]
  array:set cwf 5 patches with [pxcor < x - 3 AND pxcor > x - 41 AND (pycor = 55 OR pycor = 56)]
  array:set cwl 5 patches with [pxcor < x - 3 AND pxcor > x - 41 AND pycor = 57]

  array:set clockNorth 5 patches with [pxcor = x AND pycor = 114]
  array:set clockSouth 5 patches with [pxcor = x AND pycor = 0]

  set x 140 + 281 * 6
  array:set pedn 6 patches with [pycor = 61  AND (pxcor = x + 3 OR pxcor = x - 4)]
  array:set pedw 6 patches with [pxcor = x - 4 AND (pycor = 60 OR pycor = 53)]
  array:set peds 6 patches with [pycor = 53 AND (pxcor = x - 3 OR pxcor = x + 4)]
  array:set pede 6 patches with [pxcor = x + 4 AND (pycor = 54 OR pycor = 61)]
  array:set ecr  6 patches with [(pxcor = x + 3 OR pxcor = x + 4)AND pycor = 60]
  array:set ecf  6 patches with [(pxcor = x + 3 OR pxcor = x + 4)AND ( pycor = 58 OR pycor = 59)]
  array:set ecl  6 patches with [(pxcor = x + 3 OR pxcor = x + 4)AND pycor = 57]
  array:set ncr  6 patches with [(pycor = 60 OR pycor = 61) AND pxcor = x - 3]
  array:set ncf  6 patches with [(pycor = 60 OR pycor = 61) AND ( pxcor = x - 2 OR pxcor = x - 1)]
  array:set ncl  6 patches with [(pycor = 60 OR pycor = 61) AND pxcor = x]
  array:set wcr  6 patches with [(pxcor = x - 3 OR pxcor = x - 4) AND pycor = 54]
  array:set wcf  6 patches with [(pxcor = x - 3 OR pxcor = x - 4) AND (pycor = 55 OR pycor = 56)]
  array:set wcl  6 patches with [(pxcor = x - 3 OR pxcor = x - 4) AND pycor = 57]
  array:set scr  6 patches with [(pycor = 54 OR pycor = 53) AND pxcor = x + 3]
  array:set scf  6 patches with [(pycor = 54 OR pycor = 53) AND (pxcor = x + 2 OR pxcor = x + 1)]
  array:set scl  6 patches with [(pycor = 54 OR pycor = 53) AND pxcor = x]

  array:set cnr 6 patches with [pycor > 60 AND pycor < 98 AND pxcor = x - 3]
  array:set cnf 6 patches with [pycor > 60 AND pycor < 98 AND (pxcor = x - 2 OR pxcor = x - 1)]
  array:set cnl 6 patches with [pycor > 60 AND pycor < 98 AND pxcor = x]
  array:set cer 6 patches with [pxcor > x + 3 AND pxcor < x + 41 AND pycor = 60]
  array:set cef 6 patches with [pxcor > x + 3 AND pxcor < x + 41 AND (pycor = 58 OR pycor = 59)]
  array:set cel 6 patches with [pxcor > x + 3 AND pxcor < x + 41 AND pycor = 57]
  array:set csr 6 patches with [pycor > 16 AND pycor < 54 AND pxcor = x + 3]
  array:set csf 6 patches with [pycor > 16 AND pycor < 54 AND (pxcor = x + 1 OR pxcor = x + 2)]
  array:set csl 6 patches with [pycor > 16 AND pycor < 54 AND pxcor = x]
  array:set cwr 6 patches with [pxcor < x - 3 AND pxcor > x - 41 AND pycor = 54]
  array:set cwf 6 patches with [pxcor < x - 3 AND pxcor > x - 41 AND (pycor = 55 OR pycor = 56)]
  array:set cwl 6 patches with [pxcor < x - 3 AND pxcor > x - 41 AND pycor = 57]

  array:set clockNorth 6 patches with [pxcor = x AND pycor = 114]
  array:set clockSouth 6 patches with [pxcor = x AND pycor = 0]

  set x 140 + 281 * 7
  array:set pedn 7 patches with [pycor = 61  AND (pxcor = x + 3 OR pxcor = x - 4)]
  array:set pedw 7 patches with [pxcor = x - 4 AND (pycor = 60 OR pycor = 53)]
  array:set peds 7 patches with [pycor = 53 AND (pxcor = x - 3 OR pxcor = x + 4)]
  array:set pede 7 patches with [pxcor = x + 4 AND (pycor = 54 OR pycor = 61)]
  array:set ecr  7 patches with [(pxcor = x + 3 OR pxcor = x + 4)AND pycor = 60]
  array:set ecf  7 patches with [(pxcor = x + 3 OR pxcor = x + 4)AND ( pycor = 58 OR pycor = 59)]
  array:set ecl  7 patches with [(pxcor = x + 3 OR pxcor = x + 4)AND pycor = 57]
  array:set ncr  7 patches with [(pycor = 60 OR pycor = 61) AND pxcor = x - 3]
  array:set ncf  7 patches with [(pycor = 60 OR pycor = 61) AND ( pxcor = x - 2 OR pxcor = x - 1)]
  array:set ncl  7 patches with [(pycor = 60 OR pycor = 61) AND pxcor = x]
  array:set wcr  7 patches with [(pxcor = x - 3 OR pxcor = x - 4) AND pycor = 54]
  array:set wcf  7 patches with [(pxcor = x - 3 OR pxcor = x - 4) AND (pycor = 55 OR pycor = 56)]
  array:set wcl  7 patches with [(pxcor = x - 3 OR pxcor = x - 4) AND pycor = 57]
  array:set scr  7 patches with [(pycor = 54 OR pycor = 53) AND pxcor = x + 3]
  array:set scf  7 patches with [(pycor = 54 OR pycor = 53) AND (pxcor = x + 2 OR pxcor = x + 1)]
  array:set scl  7 patches with [(pycor = 54 OR pycor = 53) AND pxcor = x]

  array:set cnr 7 patches with [pycor > 60 AND pycor < 98 AND pxcor = x - 3]
  array:set cnf 7 patches with [pycor > 60 AND pycor < 98 AND (pxcor = x - 2 OR pxcor = x - 1)]
  array:set cnl 7 patches with [pycor > 60 AND pycor < 98 AND pxcor = x]
  array:set cer 7 patches with [pxcor > x + 3 AND pxcor < x + 41 AND pycor = 60]
  array:set cef 7 patches with [pxcor > x + 3 AND pxcor < x + 41 AND (pycor = 58 OR pycor = 59)]
  array:set cel 7 patches with [pxcor > x + 3 AND pxcor < x + 41 AND pycor = 57]
  array:set csr 7 patches with [pycor > 16 AND pycor < 54 AND pxcor = x + 3]
  array:set csf 7 patches with [pycor > 16 AND pycor < 54 AND (pxcor = x + 1 OR pxcor = x + 2)]
  array:set csl 7 patches with [pycor > 16 AND pycor < 54 AND pxcor = x]
  array:set cwr 7 patches with [pxcor < x - 3 AND pxcor > x - 41 AND pycor = 54]
  array:set cwf 7 patches with [pxcor < x - 3 AND pxcor > x - 41 AND (pycor = 55 OR pycor = 56)]
  array:set cwl 7 patches with [pxcor < x - 3 AND pxcor > x - 41 AND pycor = 57]

  array:set clockNorth 7 patches with [pxcor = x AND pycor = 114]
  array:set clockSouth 7 patches with [pxcor = x AND pycor = 0]

  set x 140 + 281 * 8
  array:set pedn 8 patches with [pycor = 61  AND (pxcor = x + 3 OR pxcor = x - 4)]
  array:set pedw 8 patches with [pxcor = x - 4 AND (pycor = 60 OR pycor = 53)]
  array:set peds 8 patches with [pycor = 53 AND (pxcor = x - 3 OR pxcor = x + 4)]
  array:set pede 8 patches with [pxcor = x + 4 AND (pycor = 54 OR pycor = 61)]
  array:set ecr  8 patches with [(pxcor = x + 3 OR pxcor = x + 4)AND pycor = 60]
  array:set ecf  8 patches with [(pxcor = x + 3 OR pxcor = x + 4)AND ( pycor = 58 OR pycor = 59)]
  array:set ecl  8 patches with [(pxcor = x + 3 OR pxcor = x + 4)AND pycor = 57]
  array:set ncr  8 patches with [(pycor = 60 OR pycor = 61) AND pxcor = x - 3]
  array:set ncf  8 patches with [(pycor = 60 OR pycor = 61) AND ( pxcor = x - 2 OR pxcor = x - 1)]
  array:set ncl  8 patches with [(pycor = 60 OR pycor = 61) AND pxcor = x]
  array:set wcr  8 patches with [(pxcor = x - 3 OR pxcor = x - 4) AND pycor = 54]
  array:set wcf  8 patches with [(pxcor = x - 3 OR pxcor = x - 4) AND (pycor = 55 OR pycor = 56)]
  array:set wcl  8 patches with [(pxcor = x - 3 OR pxcor = x - 4) AND pycor = 57]
  array:set scr  8 patches with [(pycor = 54 OR pycor = 53) AND pxcor = x + 3]
  array:set scf  8 patches with [(pycor = 54 OR pycor = 53) AND (pxcor = x + 2 OR pxcor = x + 1)]
  array:set scl  8 patches with [(pycor = 54 OR pycor = 53) AND pxcor = x]

  array:set cnr 8 patches with [pycor > 60 AND pycor < 98 AND pxcor = x - 3]
  array:set cnf 8 patches with [pycor > 60 AND pycor < 98 AND (pxcor = x - 2 OR pxcor = x - 1)]
  array:set cnl 8 patches with [pycor > 60 AND pycor < 98 AND pxcor = x]
  array:set cer 8 patches with [pxcor > x + 3 AND pxcor < x + 41 AND pycor = 60]
  array:set cef 8 patches with [pxcor > x + 3 AND pxcor < x + 41 AND (pycor = 58 OR pycor = 59)]
  array:set cel 8 patches with [pxcor > x + 3 AND pxcor < x + 41 AND pycor = 57]
  array:set csr 8 patches with [pycor > 16 AND pycor < 54 AND pxcor = x + 3]
  array:set csf 8 patches with [pycor > 16 AND pycor < 54 AND (pxcor = x + 1 OR pxcor = x + 2)]
  array:set csl 8 patches with [pycor > 16 AND pycor < 54 AND pxcor = x]
  array:set cwr 8 patches with [pxcor < x - 3 AND pxcor > x - 41 AND pycor = 54]
  array:set cwf 8 patches with [pxcor < x - 3 AND pxcor > x - 41 AND (pycor = 55 OR pycor = 56)]
  array:set cwl 8 patches with [pxcor < x - 3 AND pxcor > x - 41 AND pycor = 57]

  array:set clockNorth 8 patches with [pxcor = x AND pycor = 114]
  array:set clockSouth 8 patches with [pxcor = x AND pycor = 0]

  set x 140 + 281 * 9
  array:set pedn 9 patches with [pycor = 61  AND (pxcor = x + 3 OR pxcor = x - 4)]
  array:set pedw 9 patches with [pxcor = x - 4 AND (pycor = 60 OR pycor = 53)]
  array:set peds 9 patches with [pycor = 53 AND (pxcor = x - 3 OR pxcor = x + 4)]
  array:set pede 9 patches with [pxcor = x + 4 AND (pycor = 54 OR pycor = 61)]
  array:set ecr  9 patches with [(pxcor = x + 3 OR pxcor = x + 4)AND pycor = 60]
  array:set ecf  9 patches with [(pxcor = x + 3 OR pxcor = x + 4)AND ( pycor = 58 OR pycor = 59)]
  array:set ecl  9 patches with [(pxcor = x + 3 OR pxcor = x + 4)AND pycor = 57]
  array:set ncr  9 patches with [(pycor = 60 OR pycor = 61) AND pxcor = x - 3]
  array:set ncf  9 patches with [(pycor = 60 OR pycor = 61) AND ( pxcor = x - 2 OR pxcor = x - 1)]
  array:set ncl  9 patches with [(pycor = 60 OR pycor = 61) AND pxcor = x]
  array:set wcr  9 patches with [(pxcor = x - 3 OR pxcor = x - 4) AND pycor = 54]
  array:set wcf  9 patches with [(pxcor = x - 3 OR pxcor = x - 4) AND (pycor = 55 OR pycor = 56)]
  array:set wcl  9 patches with [(pxcor = x - 3 OR pxcor = x - 4) AND pycor = 57]
  array:set scr  9 patches with [(pycor = 54 OR pycor = 53) AND pxcor = x + 3]
  array:set scf  9 patches with [(pycor = 54 OR pycor = 53) AND (pxcor = x + 2 OR pxcor = x + 1)]
  array:set scl  9 patches with [(pycor = 54 OR pycor = 53) AND pxcor = x]

  array:set cnr 9 patches with [pycor > 60 AND pycor < 98 AND pxcor = x - 3]
  array:set cnf 9 patches with [pycor > 60 AND pycor < 98 AND (pxcor = x - 2 OR pxcor = x - 1)]
  array:set cnl 9 patches with [pycor > 60 AND pycor < 98 AND pxcor = x]
  array:set cer 9 patches with [pxcor > x + 3 AND pxcor < x + 41 AND pycor = 60]
  array:set cef 9 patches with [pxcor > x + 3 AND pxcor < x + 41 AND (pycor = 58 OR pycor = 59)]
  array:set cel 9 patches with [pxcor > x + 3 AND pxcor < x + 41 AND pycor = 57]
  array:set csr 9 patches with [pycor > 16 AND pycor < 54 AND pxcor = x + 3]
  array:set csf 9 patches with [pycor > 16 AND pycor < 54 AND (pxcor = x + 1 OR pxcor = x + 2)]
  array:set csl 9 patches with [pycor > 16 AND pycor < 54 AND pxcor = x]
  array:set cwr 9 patches with [pxcor < x - 3 AND pxcor > x - 41 AND pycor = 54]
  array:set cwf 9 patches with [pxcor < x - 3 AND pxcor > x - 41 AND (pycor = 55 OR pycor = 56)]
  array:set cwl 9 patches with [pxcor < x - 3 AND pxcor > x - 41 AND pycor = 57]

  array:set clockNorth 9 patches with [pxcor = x AND pycor = 114]
  array:set clockSouth 9 patches with [pxcor = x AND pycor = 0]

  set x 140 + 281 * 10
  array:set pedn 10 patches with [pycor = 61  AND (pxcor = x + 3 OR pxcor = x - 4)]
  array:set pedw 10 patches with [pxcor = x - 4 AND (pycor = 60 OR pycor = 53)]
  array:set peds 10 patches with [pycor = 53 AND (pxcor = x - 3 OR pxcor = x + 4)]
  array:set pede 10 patches with [pxcor = x + 4 AND (pycor = 54 OR pycor = 61)]
  array:set ecr  10 patches with [(pxcor = x + 3 OR pxcor = x + 4)AND pycor = 60]
  array:set ecf  10 patches with [(pxcor = x + 3 OR pxcor = x + 4)AND ( pycor = 58 OR pycor = 59)]
  array:set ecl  10 patches with [(pxcor = x + 3 OR pxcor = x + 4)AND pycor = 57]
  array:set ncr  10 patches with [(pycor = 60 OR pycor = 61) AND pxcor = x - 3]
  array:set ncf  10 patches with [(pycor = 60 OR pycor = 61) AND ( pxcor = x - 2 OR pxcor = x - 1)]
  array:set ncl  10 patches with [(pycor = 60 OR pycor = 61) AND pxcor = x]
  array:set wcr  10 patches with [(pxcor = x - 3 OR pxcor = x - 4) AND pycor = 54]
  array:set wcf  10 patches with [(pxcor = x - 3 OR pxcor = x - 4) AND (pycor = 55 OR pycor = 56)]
  array:set wcl  10 patches with [(pxcor = x - 3 OR pxcor = x - 4) AND pycor = 57]
  array:set scr  10 patches with [(pycor = 54 OR pycor = 53) AND pxcor = x + 3]
  array:set scf  10 patches with [(pycor = 54 OR pycor = 53) AND (pxcor = x + 2 OR pxcor = x + 1)]
  array:set scl  10 patches with [(pycor = 54 OR pycor = 53) AND pxcor = x]

  array:set cnr 10 patches with [pycor > 60 AND pycor < 98 AND pxcor = x - 3]
  array:set cnf 10 patches with [pycor > 60 AND pycor < 98 AND (pxcor = x - 2 OR pxcor = x - 1)]
  array:set cnl 10 patches with [pycor > 60 AND pycor < 98 AND pxcor = x]
  array:set cer 10 patches with [pxcor > x + 3 AND pxcor < x + 41 AND pycor = 60]
  array:set cef 10 patches with [pxcor > x + 3 AND pxcor < x + 41 AND (pycor = 58 OR pycor = 59)]
  array:set cel 10 patches with [pxcor > x + 3 AND pxcor < x + 41 AND pycor = 57]
  array:set csr 10 patches with [pycor > 16 AND pycor < 54 AND pxcor = x + 3]
  array:set csf 10 patches with [pycor > 16 AND pycor < 54 AND (pxcor = x + 1 OR pxcor = x + 2)]
  array:set csl 10 patches with [pycor > 16 AND pycor < 54 AND pxcor = x]
  array:set cwr 10 patches with [pxcor < x - 3 AND pxcor > x - 41 AND pycor = 54]
  array:set cwf 10 patches with [pxcor < x - 3 AND pxcor > x - 41 AND (pycor = 55 OR pycor = 56)]
  array:set cwl 10 patches with [pxcor < x - 3 AND pxcor > x - 41 AND pycor = 57]

  array:set clockNorth 10 patches with [pxcor = x AND pycor = 114]
  array:set clockSouth 10 patches with [pxcor = x AND pycor = 0]

  set x 140 + 281 * 11
  array:set pedn 11 patches with [pycor = 61  AND (pxcor = x + 3 OR pxcor = x - 4)]
  array:set pedw 11 patches with [pxcor = x - 4 AND (pycor = 60 OR pycor = 53)]
  array:set peds 11 patches with [pycor = 53 AND (pxcor = x - 3 OR pxcor = x + 4)]
  array:set pede 11 patches with [pxcor = x + 4 AND (pycor = 54 OR pycor = 61)]
  array:set ecr  11 patches with [(pxcor = x + 3 OR pxcor = x + 4)AND pycor = 60]
  array:set ecf  11 patches with [(pxcor = x + 3 OR pxcor = x + 4)AND ( pycor = 58 OR pycor = 59)]
  array:set ecl  11 patches with [(pxcor = x + 3 OR pxcor = x + 4)AND pycor = 57]
  array:set ncr  11 patches with [(pycor = 60 OR pycor = 61) AND pxcor = x - 3]
  array:set ncf  11 patches with [(pycor = 60 OR pycor = 61) AND ( pxcor = x - 2 OR pxcor = x - 1)]
  array:set ncl  11 patches with [(pycor = 60 OR pycor = 61) AND pxcor = x]
  array:set wcr  11 patches with [(pxcor = x - 3 OR pxcor = x - 4) AND pycor = 54]
  array:set wcf  11 patches with [(pxcor = x - 3 OR pxcor = x - 4) AND (pycor = 55 OR pycor = 56)]
  array:set wcl  11 patches with [(pxcor = x - 3 OR pxcor = x - 4) AND pycor = 57]
  array:set scr  11 patches with [(pycor = 54 OR pycor = 53) AND pxcor = x + 3]
  array:set scf  11 patches with [(pycor = 54 OR pycor = 53) AND (pxcor = x + 2 OR pxcor = x + 1)]
  array:set scl  11 patches with [(pycor = 54 OR pycor = 53) AND pxcor = x]

  array:set cnr 11 patches with [pycor > 60 AND pycor < 98 AND pxcor = x - 3]
  array:set cnf 11 patches with [pycor > 60 AND pycor < 98 AND (pxcor = x - 2 OR pxcor = x - 1)]
  array:set cnl 11 patches with [pycor > 60 AND pycor < 98 AND pxcor = x]
  array:set cer 11 patches with [pxcor > x + 3 AND pxcor < x + 41 AND pycor = 60]
  array:set cef 11 patches with [pxcor > x + 3 AND pxcor < x + 41 AND (pycor = 58 OR pycor = 59)]
  array:set cel 11 patches with [pxcor > x + 3 AND pxcor < x + 41 AND pycor = 57]
  array:set csr 11 patches with [pycor > 16 AND pycor < 54 AND pxcor = x + 3]
  array:set csf 11 patches with [pycor > 16 AND pycor < 54 AND (pxcor = x + 1 OR pxcor = x + 2)]
  array:set csl 11 patches with [pycor > 16 AND pycor < 54 AND pxcor = x]
  array:set cwr 11 patches with [pxcor < x - 3 AND pxcor > x - 41 AND pycor = 54]
  array:set cwf 11 patches with [pxcor < x - 3 AND pxcor > x - 41 AND (pycor = 55 OR pycor = 56)]
  array:set cwl 11 patches with [pxcor < x - 3 AND pxcor > x - 41 AND pycor = 57]

  array:set clockNorth 11 patches with [pxcor = x AND pycor = 114]
  array:set clockSouth 11 patches with [pxcor = x AND pycor = 0]





end

to setupIntersections
   ;als je meer kruising wil toevoegen maak boven bij globels een "I...". Set hem hier beneden en stop het in de lijst "SystemIntersectionList"
   set I1 140
   set I2 421
   set I3 702
   set I4 983
   set I5 1264 set I6 1545 set I7 1826    set I8 2107    set I9 2388    set I10 2669    set I11 2950    set I12 3231
   let D []
   set D lput I1 D set D lput I2 D set D lput I3 D set D lput I4 D set D lput I5 D set D lput I6 D set D lput I7 D set D lput I8 D set D lput I9 D set D lput I10 D set D lput I11 D set D lput I12 D
   set systemIntersectionList D
   set systemIntersectionActiveList []
   set systemIntersectionActiveTimeList []
   set systemIntersectionCurrentStateList []
   repeat (length systemIntersectionList) [set systemIntersectionActiveList lput True systemIntersectionActiveList]
   repeat (length systemIntersectionList) [set systemIntersectionActiveTimeList lput 0 systemIntersectionActiveTimeList]
   repeat (length systemIntersectionList) [set systemIntersectionCurrentStateList lput [0 4 8 12] systemIntersectionCurrentStateList]


end

to setupLigthStates
   ;0 pedn  ;1 cnr  ;2 cnf  ;3 cnl
  ;4 pede  ;5 cer  ;6 cef  ;7 cel
  ;8 peds  ;9 csr  ;10 csf  ;11 csl
  ;12 pedw  ;13 cwr  ;14 cwf  ;15 cwl
  ; All pedestrians green, all car lights red.
  let s1 [0 4 8 12]
  ; 4 rotations of one right turn car lane green ,one right turn lane green and 2 pedestrian routes green.
  let s2 [1 15 4 8]
  let s3 [5 3 8 12]
  let s4 [9 7 12 0]
  let s5 [13 11 0 4]
  ; 4 rotations of two right turn car lanes green, one straight car lane green, 1 pedestrian routes green.
  let s6 [13 1 10 4]
  let s7 [1 5 14 8]
  let s8 [5 9 2 12]
  let s9 [9 13 6 0]
  ; All right turn car lanes green.
  let s10 [1 5 9 13]
  ; 2 rotoations of two right turn car lanes green and two straight car lanes green.
  let s11 [1 2 9 10]
  let s12 [5 6 13 14]
  ; 4 rotations of three right turn car lanes green and one straight car lanes green.
  let s13 [1 2 5 9]
  let s14 [5 6 9 13]
  let s15 [9 10 13 1]
  let s16 [13 14 1 5]
  ; 4 rotations of two right turn car lanes green, one left turn car lane and one straight car lane green.
  let s17 [1 2 3 5]
  let s18 [5 6 7 9 ]
  let s19 [9 10 11 13]
  let s20 [13 14 15 1]
  ; 4 rotations of three right turn car lanes green and one left turn car lane green.
  let s21 [1 3 5 13]
  let s22 [5 7 9 1]
  let s23 [9 11 13 5]
  let s24 [13 15 1 9]
  ; 4 rotations of one left and straight car lane green, one right turn lane green and one pedestrian route green.
  let s25 [12 2 3 5]
  let s26 [0 6 7 9]
  let s27 [4 10 11 13]
  let s28 [8 14 15 1]
  ; 4 rotations of two straight car lanes green, one right turn car lane green and one pedestrain route green.
  let s29 [1 2 4 10]
  let s30 [5 6 7 14]
  let s31 [9 10 11 2]
  let s32 [13 14 0 6]
  ; 2 rotations of two straight car lanes green and 2 pedestrain routes green.
  let s33 [0 2 8 10]
  let s34 [4 6 12 14]

  ;set all states in a list
  let state [] ; make a dummie list
  set state lput s1 state set state lput s2 state set state lput s3 state set state lput s4 state set state lput s5 state
  set state lput s6 state set state lput s7 state set state lput s8 state set state lput s9 state set state lput s10 state
  set state lput s11 state set state lput s12 state set state lput s13 state set state lput s14 state set state lput s15 state
  set state lput s16 state set state lput s17 state set state lput s18 state set state lput s19 state set state lput s20 state
  set state lput s21 state set state lput s22 state set state lput s23 state set state lput s24 state set state lput s25 state
  set state lput s26 state set state lput s27 state set state lput s28 state set state lput s29 state set state lput s30 state
  set state lput s31 state set state lput s32 state set state lput s33 state set state lput s34 state
  set systemLightStateList state
end

to-report TimeNeeded [a v d maxv]
   let Tdummy 0
  while [d > 0] [
    if (v < maxv) [
      set v v + a
      if (v > maxv) [
      set v maxv
      ]
    ]
    if (v > maxv) [
      set v maxv
    ]
    set d d - v
    set Tdummy Tdummy + 1
  ]
  report Tdummy
end

to setupCostFunction
  set CAR_C (1 / 15) ; heb ik uit java bestand van vorige groep gehaald
  set PED_C (1 / 18.5) ; heb ik uit java bestand van vorige groep gehaald
  set CAR_T (400) ; heb ik uit java bestand van vorige groep gehaald
  set PED_T (500) ; heb ik uit java bestand van vorige groep gehaald
  set CAR_P 10000;
  set PED_P 10000;
end

to goligth
  foreach systemIntersectionList [ ?1 ->
   let XcorIntersection ?1
   let intersectionNumber position ?1 systemIntersectionList
   if-else (item intersectionNumber systemIntersectionActiveList = false) [
     setStateLightColor item intersectionNumber systemIntersectionCurrentStateList "green" intersectionNumber
     set systemIntersectionActiveList replace-item intersectionNumber systemIntersectionActiveList true
   ] [
    if (item intersectionNumber systemIntersectionActiveTimeList < 1) [
     set systemIntersectionActiveList replace-item intersectionNumber  systemIntersectionActiveList false
     let oldState item intersectionNumber systemIntersectionCurrentStateList
     let newState calculateHighestCostState intersectionNumber
     ;check if new state has light that are same as old state. So does not put them on red
        foreach oldState [?2 ->
       if (member? ?2 newState) [
           set oldState remove ?2 oldState
        ]
     ]
      setStateLightColor oldState "red" intersectionNumber
      set systemIntersectionCurrentStateList replace-item intersectionNumber systemIntersectionCurrentStateList newState
      set systemIntersectionActiveTimeList replace-item intersectionNumber systemIntersectionActiveTimeList calculateActiveTimeForState newState
    ]
   ]
  ]
  set GLobleTime item 0 systemIntersectionActiveTimeList

  let k 0
  while [k < length systemIntersectionActiveTimeList][
    set systemIntersectionActiveTimeList replace-item k systemIntersectionActiveTimeList (item k systemIntersectionActiveTimeList - 1)
    set k k + 1
  ]
end

to setStateLightColor[state newcolor intersectionNumber]
  let newCARcolor 0
  let newPEDcolor 0
  if-else (newcolor = "red")
  [ set newCARcolor 12
    set newPEDcolor 5
  ][
    set newCARcolor 55
    set newPEDcolor 53
  ]
  let n intersectionNumber
  foreach state [?1 ->
  let k ?1
  if (k = 0) [ask array:item pedn n [set pcolor newPEDcolor]]
  if (k = 1) [ask array:item ncr n [set pcolor newCARcolor]]
  if (k = 2) [ask array:item ncf n [set pcolor newCARcolor]]
  if (k = 3) [ask array:item ncl n [set pcolor newCARcolor]]
  if (k = 4) [ask array:item pede n [set pcolor newPEDcolor]]
  if (k = 5) [ask array:item ecr n [set pcolor newCARcolor]]
  if (k = 6) [ask array:item ecf n [set pcolor newCARcolor]]
  if (k = 7) [ask array:item ecl n [set pcolor newCARcolor]]
  if (k = 8) [ask array:item peds n [set pcolor newPEDcolor]]
  if (k = 9) [ask array:item scr n [set pcolor newCARcolor]]
  if (k = 10) [ask array:item scf n [set pcolor newCARcolor]]
  if (k = 11) [ask array:item scl n [set pcolor newCARcolor]]
  if (k = 12) [ask array:item pedw n [set pcolor newPEDcolor]]
  if (k = 13) [ask array:item wcr n [set pcolor newCARcolor]]
  if (k = 14) [ask array:item wcf n [set pcolor newCARcolor]]
  if (k = 15) [ask array:item wcl n [set pcolor newCARcolor]]
    ]

end

to-report calculateActiveTimeForState[state]
  let TstateList []
  foreach state [?1 ->
     ;type ?1
    if-else (?1 mod 4 = 0) [][
      ;type " 0 "
   let patchArea item ?1 carsPatchList
      let accC [] let speedC [] let distanceC [] let maxspeedC [] let numberOfCars [] let carNumber []
    ask cars-on patchArea [
       set carNumber lput who carNumber
       set accC lput acceleration accC
       set speedC lput speed speedC
       set maxspeedC lput maxspeed maxspeedC
       let d checkDistanceToLight 1
       set distanceC lput d distanceC
       ;print d
       set numberOfCars lput checkCarsBetweenSelfAndLight d numberOfCars
       ;print "done"
    ]
      let TLightList []
       ;type " 1d "
       ;print carNumber print accC print speedC print distanceC
      foreach carNumber [?2 ->
        let index position ?2 carNumber
        let a item index accC
        let v item index speedC
        let d item index distanceC
        let maxv item index maxspeedC
        let c item index numberOfCars
        let t 5 + 4 * c + ceiling (TimeNeeded a v d maxv)
        ; type " 1f2 "
        set TLightlist lput t TLightlist
        ; type " 1f3 "
      ]
      ;type " 1 "
      if-else ( empty? TLightlist) [ ][
        set TStatelist lput max TLightList TStatelist]
    ]
  ]
  let runTimeLight 10 ; ;minimum time for state light
  if (not empty? TStatelist) [
  if (max TStatelist >= runTimeLight )[
      set runTimeLight max TStatelist]]
  report runTimeLight

end

to-report checkDistanceToLight [n]
  if-else ([pcolor] of patch-ahead n = green OR [pcolor] of patch-ahead n = 12 ) [report n][report checkDistanceToLight (n + 1)]
end

to-report checkCarsBetweenSelfAndLight [n]
  let k 1
  let turtlesAmount 0
  while [k < n] [
    set turtlesAmount  turtlesAmount + count (turtles-on ( patch-ahead k )) with [stopped = 1]
    set k k + 1
  ]
  report turtlesAmount
end

to-report carCheck [carPatch side intersectionNumber newRange oldcarsamount oldCarPatch]
 let newCarPatch oldCarPatch
 let checkRange newRange
 let maxCheckRange 38
 if-else (checkRange >  maxCheckRange)[report newCarPatch] [

 let x (140 + intersectionNumber * 281)
 if (side = "n") [
    set newCarPatch  carPatch with [pycor <(60 + checkRange)]
 ]
  if (side = "e") [
    set newCarPatch  carPatch with [pxcor <(x + 3 + checkRange)]
 ]
  if (side = "s") [
    set newCarPatch  carPatch with [pycor > (54 - checkRange)]
 ]
  if (side = "w") [
    set newCarPatch  carPatch with [pxcor > (x - 3  - checkRange)]
 ]

 let carsamount count turtles-on newCarPatch
 set checkRange newRange + 3 * (carsamount - oldcarsamount)
 if-else((carsamount - oldcarsamount) > 0) [report carCheck carPatch side intersectionNumber checkRange carsamount newCarPatch ] [report newCarPatch]
 ]
end

to-report calculateHighestCostState[intersectionNumber]
  let costPerLight calculateCostPerCarLight intersectionNumber
  let costPerState []
  foreach systemLightStateList [?1 ->
    let state ?1
    let cost 0
   foreach state [?2 ->
    set cost cost + item ?2 costPerlight
    ]
   set costPerState lput cost costPerState
  ]


   ;print costPerState
   let bestState 0
   foreach costPerstate [ ?1 ->
     if (item bestState costPerState < ?1)[
       set bestState position ?1 costPerState
     ]
   ]


  ;monitor
  foreach costPerState [?1 ->
    set costPerState replace-item position ?1 costPerState costPerState precision ?1 2
  ]
  foreach costPerLight [?2 ->
    set costPerLight replace-item position ?2 costPerLight costPerLight precision ?2 2
  ]
  if (intersectionNumber = 0) [
    set globleCostFuctionStateListIntersectoin0 costPerState
    set globleWinner bestState + 1
    set globleCostPerLightListIntersectoin0 costPerLight
    set globleCarPerLightListIntersectoin0 carsLightList

  ]



   report item bestState systemLightStateList
end

to-report calculateCostCarLight[areaLight side intersectionNumber greenwave] ;greenwave = (0,1,2): 0 = greenwave in rechtse directie. 1 = greenwave in linkse directie. 2 = geen greenwave
  let area areaLight
  let amountOfCars count turtles-on area; begin check
  set carsPatchList lput area carsPatchList
  let maxWaitingTime 0
  if(amountOfCars > 0) [set maxWaitingTime [stoptime] of max-one-of turtles-on area [stoptime]]
  set carsLightList lput amountOfCars carsLightList
  set maxWaitingTimeLightList lput maxWaitingTime maxWaitingTimeLightList
  if (greenwave = 0 AND any? turtles-on array:item clockNorth intersectionNumber) [set amountOfCars amountOfCars ^ ([clockweight] of max-one-of turtles-on (array:item clockNorth intersectionNumber)[clockweight])]
  if (greenwave = 1 AND any? turtles-on array:item clockSouth intersectionNumber) [set amountOfCars amountOfCars ^ ([clockweight] of max-one-of turtles-on (array:item clockSouth intersectionNumber)[clockweight])]
  let cost 0 if-else (maxWaitingTime < CAR_T) [set cost amountOfCars + CAR_C * maxWaitingTime][set cost amountOfCars + CAR_C * maxWaitingTime + CAR_P ]

  report cost
end

to-report calculateCostPedLight[areaLight]
  let ped? any? turtles-on areaLight
  let maxWaitingTime 0
  if(ped? = true) [set maxWaitingTime [stoptime] of max-one-of turtles-on areaLight [stoptime]]
  let cost 0 if-else (maxWaitingTime < PED_T) [set cost PED_C * maxWaitingTime][set cost PED_C * maxWaitingTime + PED_P]
  set carsLightList lput 0 carsLightList
  set carsPatchList lput 0 carsPatchList
  set maxWaitingTimeLightList lput maxWaitingTime maxWaitingTimeLightList
  report cost
end

to-report clockDing [intersectionNumber directionClock]
  let Xcoor 140 +  281 * intersectionNumber
  if (directionClock = 0) [ ;rechts
    report [clockweight] of one-of turtles-on patches with [pxcor = XCoor AND pycor = 114]
  ]
  if (directionClock = 1) [ ;links
    report [clockweight] of one-of turtles-on patches with [pxcor = XCoor AND pycor = 0]
  ]
end

to-report calculateCostPerCarLight[intersectionNumber]
  let n intersectionNumber
  set costLightList []
  set carsLightList []
  set carsPatchList []
  set maxWaitingTimeLightList []

  ;pedn
  set costLightList lput calculateCostPedLight (array:item pedn n) costLightList
  ;cnr
  set costLightList lput calculateCostCarLight (array:item cnr n) "n" n 2 costLightList
  ;cnf
  set costLightList lput calculateCostCarLight (array:item cnf n) "n" n 2 costLightList
  ;cnl
  set costLightList lput calculateCostCarLight (array:item cnl n) "n" n 2 costLightList
  ;pede
  set costLightList lput calculateCostPedLight (array:item pede n) costLightList
  ;cer
  set costLightList lput calculateCostCarLight (array:item cer n) "e" n 2 costLightList
  ;cef
  set costLightList lput calculateCostCarLight (array:item cef n) "e" n 1 costLightList
  ;cel
  set costLightList lput calculateCostCarLight (array:item cel n) "e" n 2 costLightList
  ;peds
  set costLightList lput calculateCostPedLight (array:item peds n) costLightList
  ;csr
  set costLightList lput calculateCostCarLight (array:item csr n) "s" n 2 costLightList
  ;csf
 set costLightList lput calculateCostCarLight (array:item csf n) "s" n 2 costLightList
  ;csl
  set costLightList lput calculateCostCarLight (array:item csl n) "s" n 2 costLightList
  ;pedw
  set costLightList lput calculateCostPedLight (array:item pedw n) costLightList
  ;cwr
  set costLightList lput calculateCostCarLight (array:item cwr n) "w" n 2 costLightList
  ;cwf
  set costLightList lput calculateCostCarLight (array:item cwf n) "w" n 0 costLightList
  ;cwl
  set costLightList lput calculateCostCarLight (array:item cwl n) "w" n 2 costLightList
  report costLightList
end
;///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
;car movement
;///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
to move-cars

    if ((([pcolor] of patch-ahead 2 = 12 OR [pcolor] of patch-ahead 1 = 12) OR([stopped] of turtles-on patch-ahead 2 = 1 OR [stopped] of turtles-on patch-ahead 1 = 1)) AND speed = 0 AND stopped = 0)[
      set stopped  1
              set stoppedcars stoppedcars + 1
    if(length direction != 1)[
        set stoppedcarsf stoppedcarsf + 1
      ]

    if(length direction != 1 AND item 0 direction = "F")[
      set stoppedcarsr stoppedcarsr + 1
    ]
    ]
    if invoegen = 1[
   ifelse(voegrechts = 0)[
     set maxspeed  (random 4 + 1) / 10
    ][
     set maxspeed  maxspeed1
    ]
  ]
  if invoegen = 2[
    ifelse(voeglinks = 0)[
     set maxspeed  (random 4 + 1) / 10
    ] [
     set maxspeed maxspeed1
    ]
  ]
    ifelse(pcolor = red)[;dood
     set finishedcars finishedcars + 1
    if(length direction != 1)[
        set finishedcarsf finishedcarsf + 1
      set finishedtrafficlightsf finishedtrafficlightsf + destinationindex

      ifelse (avspeedf != [0])[set avspeedf lput avvspeed avspeedf][set avspeedf replace-item 0 avspeedf avvspeed]
    set timedrivenf timedrivenf + tickss
      set totaldistancedrivenf totaldistancedrivenf + distancedriven
    ]



      set finishedtrafficlights finishedtrafficlights + destinationindex

    ifelse (avspeed != [0])[set avspeed lput avvspeed avspeed][set avspeed replace-item 0 avspeed avvspeed]
      set timedriven timedriven + tickss
      set totaldistancedriven totaldistancedriven + distancedriven
      die
    ][
      ifelse(pcolor = green AND turned = 0)[;rij door
      set ycor  round ycor
      set xcor  round xcor
        set turned  1
      if (destination = "R")[
         fd  2
          set distancedriven distancedriven + 2
         right 90
          fd 1
          set distancedriven distancedriven + 1
          set strook 0
          set maxspeed maxspeedglobal
          set shape "car top"
        ]
      if (destination = "L")[
          fd 5
          set distancedriven distancedriven + 5
          left 90
          set strook 0
          set maxspeed maxspeedglobal
          set shape "car top"
        ]
  ][
        ifelse(pcolor = 1)[;voeg hier in
          if (destination = "L")[
           if(voeglinks = 0)[
              set maxspeed 0.2
              set invoegen 2
              set shape "carleft"
            ]
          ]
          if(destination = "R")[
           if (voegrechts = 0)[
             set maxspeed 0.2
              set invoegen 1
              set shape "carright"
              ]
          ]
        ][
          ifelse(pcolor = 31 )[;rem af voor afslaan
            if (directionhelper = 1)[
            set destination substring direction destinationindex (destinationindex + 1)
              set destinationindex destinationindex + 1
            set directionhelper 0]
            if (destination = "L" OR destination = "R")[
             set maxspeed 0.4
            ]
          ][
            ifelse(pcolor = 122)[
            set directionhelper 1
              set invoegen 0
              set maxspeed maxspeedglobal
              set stoptime 0
            ][
              ifelse(pcolor = 0)[
              set turned 0
              ][
              ]
    ]]]]]
  ifelse (move = 1) [
      drive
        ]   [
      slowdown
    ]
    set tickss tickss + 1
    set sumspeed sumspeed + speed
    set avvspeed sumspeed / tickss
  ifelse (stopped = 1 AND speed = 0)[
      set stoptime stoptime + 1
    ][
    if (stopped = 1)[
        set stopped 0
        set totalstoptime totalstoptime + stoptime
      if(length direction != 1)[
        set totalstoptimef totalstoptimef + stoptime
      ]
      if(length direction != 1 AND item 0 direction = "F")[
      set totalstoptimer totalstoptimer + stoptime
        set timesstopped timesstopped + 1
        set ringstopped ringstopped + stoptime
    ]


      ]
    ]

end

to drive
    if(speed = maxspeed)[
      fd speed
    set distancedriven distancedriven + speed
    ]
    if(speed > maxspeed)[
      set speed speed - deceleration
    if (speed < 0)[set speed 0]
    fd speed
    set distancedriven distancedriven + speed
    ]
    if(speed < maxspeed)[
      set speed speed + acceleration
      if(speed > maxspeed)[
      set speed maxspeed
      ]
      fd speed
    set distancedriven distancedriven + speed
    ]
end

to-report move
  ifelse([pcolor] of patch-at-heading-and-distance heading 1 != 12 AND [pcolor] of patch-at-heading-and-distance heading 2 != 12 AND not any? turtles-on patch-at-heading-and-distance heading 1 AND not any? turtles-on patch-at-heading-and-distance heading 2)[
    report 1]
  [report 0]
end

to slowdown
   set speed speed - deceleration
  if (speed < 0)[set speed 0]
   fd speed
  set distancedriven distancedriven + speed
end

to-report voeglinks
  ifelse(not any? turtles-on patch-left-and-ahead 90 1 AND not any? turtles-on patch-left-and-ahead 45 1 AND (pcolor = 1) )[
   left 90
   fd 1
    set distancedriven distancedriven + 1
   right 90
    set invoegen 0
    set strook strook + 1
   report 1
  ][
    set maxspeed1  maxspeed
   report 0
  ]
end

to-report voegrechts
  ifelse(not any? turtles-on patch-right-and-ahead 90 1 AND not any? turtles-on patch-right-and-ahead 45 1 AND  pcolor = 1)[
  right 90
   fd 1
    set distancedriven distancedriven + 1
   left 90
    set invoegen 0
    set strook strook - 1
   report 1
  ][
    set maxspeed1  maxspeed
    set invoegen 0
   report 0
  ]
end

to destinations
  let randoma (random 100 + 1)
  ifelse(randoma <= forward%)[
  set directionhelper "F"
  ][
    ifelse(randoma <= left%)[
    set directionhelper "L"][
      set directionhelper "R"
    ]  ]

    let randomc  random 2
  ifelse(spawneven = 1)[;even top
    if(directionhelper = "F")[set destination spawnlocation - 1]
    if(directionhelper = "L")[set destination spawnlocation + randomc * ((random 11) + 1) + (randomc - 1) * ((random 11) + 13)]
    if(directionhelper = "R")[set destination spawnlocation + randomc * ((random 11) + 12) + (randomc - 1) * ((random 11) + 2)]
  ][;odd bottom
    if(directionhelper = "F")[set destination spawnlocation + 1]
    if(directionhelper = "L")[set destination spawnlocation + randomc * ((random 11) + 13) + (randomc - 1) * ((random 11) + 1)]
    if(directionhelper = "R")[set destination spawnlocation + randomc * ((random 11) + 2) + (randomc - 1) * ((random 11) + 12)]

  ]
end

to-report directions
  set directionhelper destination - spawnlocation
    ifelse(spawneven = 1)[;even top
                                      ifelse(directionhelper = 1)  [report "LR"][
                                      ifelse(directionhelper = 2)  [report "LL"][
                                      ifelse(directionhelper = 3)  [report "LFR"][
                                      ifelse(directionhelper = 4)  [report "LFL"][
                                      ifelse(directionhelper = 5)  [report "LFFR"][
                                      ifelse(directionhelper = 6)  [report "LFFL"][
                                      ifelse(directionhelper = 7)  [report "LFFFR"][
                                      ifelse(directionhelper = 8)  [report "LFFFL"][
                                      ifelse(directionhelper = 9)  [report "LFFFFR"][
                                      ifelse(directionhelper = 10) [report "LFFFFL"][
                                      ifelse(directionhelper = 11) [report "LFFFFFR"][
                                      ifelse(directionhelper = 12) [report "RFFFFFR"][
                                      ifelse(directionhelper = 13) [report "RFFFFL"][
                                      ifelse(directionhelper = 14) [report "RFFFFR"][
                                      ifelse(directionhelper = 15) [report "RFFFL"][
                                      ifelse(directionhelper = 16) [report "RFFFR"][
                                      ifelse(directionhelper = 17) [report "RFFL"][
                                      ifelse(directionhelper = 18) [report "RFFR"][
                                      ifelse(directionhelper = 19) [report "RFL"][
                                      ifelse(directionhelper = 20) [report "RFR"][
                                      ifelse(directionhelper = 21) [report "RL"][
                                      ifelse(directionhelper = 22) [report "RR"][
                                      ifelse(directionhelper = -1) [report "F"][
                                      ifelse(directionhelper = -2) [report "RR"][
                                      ifelse(directionhelper = -3) [report "RL"][
                                      ifelse(directionhelper = -4) [report "RFR"][
                                      ifelse(directionhelper = -5) [report "RFL"][
                                      ifelse(directionhelper = -6) [report "RFFR"][
                                      ifelse(directionhelper = -7) [report "RFFL"][
                                      ifelse(directionhelper = -8) [report "RFFFR"][
                                      ifelse(directionhelper = -9) [report "RFFFL"][
                                      ifelse(directionhelper = -10)[report "RFFFFR"][
                                      ifelse(directionhelper = -11)[report "RFFFFL"][
                                      ifelse(directionhelper = -12)[report "RFFFFFR"][
                                      ifelse(directionhelper = -13)[report "LFFFFFR"][
                                      ifelse(directionhelper = -14)[report "LFFFFL"][
                                      ifelse(directionhelper = -15)[report "LFFFFR"][
                                      ifelse(directionhelper = -16)[report "LFFFL"][
                                      ifelse(directionhelper = -17)[report "LFFFR"][
                                      ifelse(directionhelper = -18)[report "LFFL"][
                                      ifelse(directionhelper = -19)[report "LFFR"][
                                      ifelse(directionhelper = -20)[report "LFL"][
                                      ifelse(directionhelper = -21)[report "LFR"][
                                      ifelse(directionhelper = -22)[report "LL"][
                                      ifelse(directionhelper = -23)[report "LR"][
                                      report no-patches]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]
  [;uneven bottom
                                      ifelse(directionhelper = 1)  [report "F"][
                                      ifelse(directionhelper = 2)  [report "RR"][
                                      ifelse(directionhelper = 3)  [report "RL"][
                                      ifelse(directionhelper = 4)  [report "RFR"][
                                      ifelse(directionhelper = 5)  [report "RFL"][
                                      ifelse(directionhelper = 6)  [report "RFFR"][
                                      ifelse(directionhelper = 7)  [report "RFFL"][
                                      ifelse(directionhelper = 8)  [report "RFFFR"][
                                      ifelse(directionhelper = 9)  [report "RFFFL"][
                                      ifelse(directionhelper = 10) [report "RFFFFR"][
                                      ifelse(directionhelper = 11) [report "RFFFFL"][
                                      ifelse(directionhelper = 12) [report "RFFFFFR"][
                                      ifelse(directionhelper = 13) [report "LFFFFFR"][
                                      ifelse(directionhelper = 14) [report "LFFFFL"][
                                      ifelse(directionhelper = 15) [report "LFFFFR"][
                                      ifelse(directionhelper = 16) [report "LFFFL"][
                                      ifelse(directionhelper = 17) [report "LFFFR"][
                                      ifelse(directionhelper = 18) [report "LFFL"][
                                      ifelse(directionhelper = 19) [report "LFFR"][
                                      ifelse(directionhelper = 20) [report "LFL"][
                                      ifelse(directionhelper = 21) [report "LFR"][
                                      ifelse(directionhelper = 22) [report "LL"][
                                      ifelse(directionhelper = 23) [report "LR"][
                                      ifelse(directionhelper = -1) [report "LR"][
                                      ifelse(directionhelper = -2) [report "LL"][
                                      ifelse(directionhelper = -3) [report "LFR"][
                                      ifelse(directionhelper = -4) [report "LFL"][
                                      ifelse(directionhelper = -5) [report "LFFR"][
                                      ifelse(directionhelper = -6) [report "LFFL"][
                                      ifelse(directionhelper = -7) [report "LFFFR"][
                                      ifelse(directionhelper = -8) [report "LFFFL"][
                                      ifelse(directionhelper = -9) [report "LFFFFR"][
                                      ifelse(directionhelper = -10)[report "LFFFFL"][
                                      ifelse(directionhelper = -11)[report "LFFFFFR"][
                                      ifelse(directionhelper = -12)[report "RFFFFFR"][
                                      ifelse(directionhelper = -13)[report "RFFFFL"][
                                      ifelse(directionhelper = -14)[report "RFFFFR"][
                                      ifelse(directionhelper = -15)[report "RFFFL"][
                                      ifelse(directionhelper = -16)[report "RFFFR"][
                                      ifelse(directionhelper = -17)[report "RFFL"][
                                      ifelse(directionhelper = -18)[report "RFFR"][
                                      ifelse(directionhelper = -19)[report "RFL"][
                                      ifelse(directionhelper = -20)[report "RFR"][
                                      ifelse(directionhelper = -21)[report "RL"][
                                      ifelse(directionhelper = -22)[report "RR"][report no-patches]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]


end

to printoutput
  clear-output
  output-print "All Cars"
  output-type "Cars that finished: " output-print precision finishedcars 2
  output-type "Average speed: " output-print precision mean(avspeed) 2
  output-type "Average times stopped per car: " output-print precision avstopped 2
  output-type "Average time stopped per stop: " output-print precision avtstopped 2
  output-type "Average time stopped per car: " output-print precision avtall 2
  output-type "Average finish time: " output-print precision averagefinish 2
  output-print " "
  output-print " "
  output-print "Cars at least a bit on the ring"
  output-type "Cars that finished: " output-print precision finishedcarsf 2
  output-type "Average speed: " output-print precision mean(avspeedf) 2
  output-type "Average times stopped per car: " output-print precision avstoppedf 2
  output-type "Average time stopped per stop: " output-print precision avtstoppedf 2
  output-type "Average time stopped per car: " output-print precision avtallf 2
  output-type "Average finish time: " output-print precision averagefinishf 2
    output-print " "
  output-print " "
  output-print "Cars going 1 full circle"
  output-type "Cars that finished: " output-print precision finishedcarsr 2
  output-type "Average speed: " output-print precision mean(avspeedr) 2
  output-type "Average times stopped per car: " output-print precision avstoppedr 2
  output-type "Average time stopped per stop: " output-print precision avtstoppedr 2
  output-type "Average time stopped per car: " output-print precision avtallr 2
  output-type "Average finish time: " output-print precision averagefinishr 2

end

to exportshit
  clear-output
  set string "1ClocksXPowerY.csv"
  set string replace-item 7 string (word AmountOfclocks)
  set string replace-item (length string - 5) string (word (Clockpower * 10))

  output-print "All Cars"
  output-type "Clocks:," output-print AmountOfClocks
  output-type "ClockPower:," output-print Clockpower
  output-type "Cars that finished:," output-print precision finishedcars 6
  output-type "Average speed:," output-print precision mean(avspeed) 6
  output-type "Average times stopped per car:," output-print precision avstopped 6
  output-type "Average time stopped per stop:," output-print precision avtstopped 6
  output-type "Average time stopped per car:," output-print precision avtall 6
  output-type "Average finish time:," output-print precision averagefinish 6
  output-print " "
  output-print " "
  output-print "Cars at least a bit on the ring"
  output-type "Cars that finished:," output-print precision finishedcarsf 6
  output-type "Average speed:," output-print precision mean(avspeedf) 6
  output-type "Average times stopped per car:," output-print precision avstoppedf 6
  output-type "Average time stopped per stop:," output-print precision avtstoppedf 6
  output-type "Average time stopped per car:," output-print precision avtallf 6
  output-type "Average finish time:," output-print precision averagefinishf 6
  output-print " "
  output-print " "
  output-print "Cars going 1 full circle"
  output-type "Cars that finished:," output-print precision finishedcarsr 6
  output-type "Average speed:," output-print precision mean(avspeedr) 6
  output-type "Average times stopped per car:," output-print precision avstoppedr 6
  output-type "Average time stopped per stop:," output-print precision avtstoppedr 6
  output-type "Average time stopped per car:," output-print precision avtallr 6
  output-type "Average finish time:," output-print precision averagefinishr 6
  output-print " "
  output-print "all ringcars"
  output-type "times stopped" output-print ringxstopped
  output-type "time stopped" output-print ringtstopped
  output-type "finish time" output-print ringfinish



  while[file-exists? string AND item 2 string != "C"][
    if(item 1 string = "C")[set string replace-item 0 string (word (read-from-string item 0 string + 1))]
    if(item 2 string = "C")[set string replace-item 0 string item 0(word ((read-from-string substring string 0 2) + 1))
                            set string replace-item 1 string item 1(word (read-from-string substring string 0 2))
  ]]
  ifelse(file-exists? string)[
    set string user-input "Saving failed, input new file name:"
    export-output string
  ][
  export-output string
  ]



end
@#$#@#$#@
GRAPHICS-WINDOW
309
10
17177
594
-1
-1
5.0
1
16
1
1
1
0
1
0
1
0
3371
0
114
1
1
1
ticks
30.0

BUTTON
20
452
154
485
Setup
setup
NIL
1
T
OBSERVER
NIL
NIL
NIL
NIL
1

BUTTON
156
452
266
485
NIL
Go
T
1
T
OBSERVER
NIL
NIL
NIL
NIL
0

SLIDER
392
632
638
665
ClockSpeed
ClockSpeed
0
0.7
0.7
0.01
1
NIL
HORIZONTAL

INPUTBOX
20
485
266
545
runfor
100000.0
1
0
Number

SLIDER
811
663
1051
696
AmountOfClocks
AmountOfClocks
0
10
0.0
1
1
NIL
HORIZONTAL

SLIDER
392
671
639
704
SpawnPercentage
SpawnPercentage
0
100
85.0
1
1
NIL
HORIZONTAL

SLIDER
812
700
1052
733
ClockPower
ClockPower
2
4
4.0
0.5
1
NIL
HORIZONTAL

BUTTON
156
545
266
579
GoOneTick
go
NIL
1
T
OBSERVER
NIL
NIL
NIL
NIL
1

BUTTON
20
545
154
579
Spawn RingCar
spawn-ringcar
NIL
1
T
OBSERVER
NIL
NIL
NIL
NIL
1

SWITCH
810
627
1051
660
RealDistribution
RealDistribution
1
1
-1000

OUTPUT
1
10
308
449
13

TEXTBOX
400
608
550
627
During go
15
0.0
0

TEXTBOX
819
603
969
622
Before setup
15
0.0
1

TEXTBOX
274
610
376
628
Can be changed:
13
0.0
1

TEXTBOX
272
639
384
657
Speed of the clock:
13
0.0
1

TEXTBOX
271
676
386
694
Percentage of cars:
13
0.0
1

TEXTBOX
662
671
800
689
Amount of clock waves:
13
0.0
1

TEXTBOX
664
711
799
729
Power of clock wave:
13
0.0
1

BUTTON
20
579
266
612
Export data
exportshit
NIL
1
T
OBSERVER
NIL
NIL
NIL
NIL
1

TEXTBOX
663
633
770
655
Distribution type:
13
0.0
1

@#$#@#$#@
##Buttons
Setup:         Sets up the modeling environment before a simulation can be ran.
Go:            Starts the simulation.
GoOneTick:     Runs one tick of the simulation.
Spawn Ringcar: Spawns a car that loops around 1 time, which is then inspected.

##Inputs
RunFor:           Maximum amount of ticks ran by the simulation.
ClockSpeed:       Speed of the green wave clock.
SpawnPercentage:  Percentage of cars being spawned.
RealDistribution: Distribution type, see below.
Amount of Clocks: Amount of waves on the clocks.
ClockPower:       Power of the clock.

##Distribution type
Distribution of cars going different directions at the start.

Realdistribution on:
16% Left
59% Straight
25% Right


Realdistribution off
30% Left
40% Straight
30% Right



##Authors and project

This simulation was written by Tim Houthuijs and Kevin Jenniskens for project group 11 of the project Robots Everywhere q3 2016
@#$#@#$#@
default
true
0
Polygon -7500403 true true 150 5 40 250 150 205 260 250

airplane
true
0
Polygon -7500403 true true 150 0 135 15 120 60 120 105 15 165 15 195 120 180 135 240 105 270 120 285 150 270 180 285 210 270 165 240 180 180 285 195 285 165 180 105 180 60 165 15

arrow
true
0
Polygon -7500403 true true 150 0 0 150 105 150 105 293 195 293 195 150 300 150

box
false
0
Polygon -7500403 true true 150 285 285 225 285 75 150 135
Polygon -7500403 true true 150 135 15 75 150 15 285 75
Polygon -7500403 true true 15 75 15 225 150 285 150 135
Line -16777216 false 150 285 150 135
Line -16777216 false 150 135 15 75
Line -16777216 false 150 135 285 75

bug
true
0
Circle -7500403 true true 96 182 108
Circle -7500403 true true 110 127 80
Circle -7500403 true true 110 75 80
Line -7500403 true 150 100 80 30
Line -7500403 true 150 100 220 30

butterfly
true
0
Polygon -7500403 true true 150 165 209 199 225 225 225 255 195 270 165 255 150 240
Polygon -7500403 true true 150 165 89 198 75 225 75 255 105 270 135 255 150 240
Polygon -7500403 true true 139 148 100 105 55 90 25 90 10 105 10 135 25 180 40 195 85 194 139 163
Polygon -7500403 true true 162 150 200 105 245 90 275 90 290 105 290 135 275 180 260 195 215 195 162 165
Polygon -16777216 true false 150 255 135 225 120 150 135 120 150 105 165 120 180 150 165 225
Circle -16777216 true false 135 90 30
Line -16777216 false 150 105 195 60
Line -16777216 false 150 105 105 60

car
false
0
Polygon -7500403 true true 300 180 279 164 261 144 240 135 226 132 213 106 203 84 185 63 159 50 135 50 75 60 0 150 0 165 0 225 300 225 300 180
Circle -16777216 true false 180 180 90
Circle -16777216 true false 30 180 90
Polygon -16777216 true false 162 80 132 78 134 135 209 135 194 105 189 96 180 89
Circle -7500403 true true 47 195 58
Circle -7500403 true true 195 195 58

car top
true
0
Polygon -7500403 true true 150 3 118 5 97 20 85 43 81 220 89 265 104 284 149 289 194 286 209 265 218 220 213 42 200 19 180 6
Polygon -16777216 true false 210 195 195 210 195 135 210 105
Polygon -16777216 true false 105 255 120 270 180 270 195 255 195 225 105 225
Polygon -16777216 true false 90 195 105 210 105 135 90 105
Polygon -1 true false 205 29 180 30 181 11
Line -7500403 true 210 165 195 165
Line -7500403 true 90 165 105 165
Polygon -16777216 true false 121 135 180 134 204 97 182 89 153 85 120 89 98 97
Line -16777216 false 210 90 195 30
Line -16777216 false 90 90 105 30
Polygon -1 true false 95 29 120 30 119 11
Line -16777216 false 118 5 96 20

carleft
true
0
Polygon -7500403 true true 151 8 119 10 98 25 86 48 82 225 90 270 105 289 150 294 195 291 210 270 219 225 214 47 201 24 181 11
Polygon -16777216 true false 210 195 195 210 195 135 210 105
Polygon -16777216 true false 105 255 120 270 180 270 195 255 195 225 105 225
Polygon -16777216 true false 90 195 105 210 105 135 90 105
Polygon -1 true false 205 29 180 30 181 11
Line -7500403 true 210 165 195 165
Line -7500403 true 90 165 105 165
Polygon -16777216 true false 121 135 180 134 204 97 182 89 153 85 120 89 98 97
Line -16777216 false 210 90 195 30
Line -16777216 false 90 90 105 30
Polygon -1 true false 95 29 120 30 119 11
Polygon -955883 true false 195 285 210 270 195 270 195 285 195 270 210 270
Circle -7500403 true true 97 267 16
Circle -955883 true false 75 270 30
Circle -955883 true false 75 0 30
Polygon -16777216 false false 91 269 82 228 85 47 94 28 115 11 155 8 182 11 203 26 215 47 218 226 211 269 196 291 145 292 105 289 100 277 92 270

carright
true
0
Polygon -7500403 true true 151 8 119 10 98 25 86 48 82 225 90 270 105 289 150 294 195 291 210 270 219 225 214 47 201 24 181 11
Polygon -16777216 true false 210 195 195 210 195 135 210 105
Polygon -16777216 true false 105 255 120 270 180 270 195 255 195 225 105 225
Polygon -16777216 true false 90 195 105 210 105 135 90 105
Polygon -1 true false 205 29 180 30 181 11
Line -7500403 true 210 165 195 165
Line -7500403 true 90 165 105 165
Polygon -16777216 true false 121 135 180 134 204 97 182 89 153 85 120 89 98 97
Line -16777216 false 210 90 195 30
Line -16777216 false 90 90 105 30
Polygon -1 true false 95 29 120 30 119 11
Polygon -955883 true false 195 285 210 270 195 270 195 285 195 270 210 270
Circle -7500403 true true 97 267 16
Circle -955883 true false 195 270 30
Circle -955883 true false 195 0 30
Polygon -16777216 false false 210 271 218 227 214 46 205 29 183 12 148 7 121 8 93 27 85 45 80 218 87 264 101 283 103 287 153 295 197 289 198 277 206 271 211 270

circle
false
0
Circle -7500403 true true 0 0 300

circle 2
false
0
Circle -955883 true false 0 0 300
Circle -16777216 true false 30 30 240
Circle -2064490 true false 60 60 180

cow
false
0
Polygon -7500403 true true 200 193 197 249 179 249 177 196 166 187 140 189 93 191 78 179 72 211 49 209 48 181 37 149 25 120 25 89 45 72 103 84 179 75 198 76 252 64 272 81 293 103 285 121 255 121 242 118 224 167
Polygon -7500403 true true 73 210 86 251 62 249 48 208
Polygon -7500403 true true 25 114 16 195 9 204 23 213 25 200 39 123

cylinder
false
0
Circle -7500403 true true 0 0 300

dot
false
0
Circle -7500403 true true 90 90 120

face happy
false
0
Circle -7500403 true true 8 8 285
Circle -16777216 true false 60 75 60
Circle -16777216 true false 180 75 60
Polygon -16777216 true false 150 255 90 239 62 213 47 191 67 179 90 203 109 218 150 225 192 218 210 203 227 181 251 194 236 217 212 240

face neutral
false
0
Circle -7500403 true true 8 7 285
Circle -16777216 true false 60 75 60
Circle -16777216 true false 180 75 60
Rectangle -16777216 true false 60 195 240 225

face sad
false
0
Circle -7500403 true true 8 8 285
Circle -16777216 true false 60 75 60
Circle -16777216 true false 180 75 60
Polygon -16777216 true false 150 168 90 184 62 210 47 232 67 244 90 220 109 205 150 198 192 205 210 220 227 242 251 229 236 206 212 183

fish
false
0
Polygon -1 true false 44 131 21 87 15 86 0 120 15 150 0 180 13 214 20 212 45 166
Polygon -1 true false 135 195 119 235 95 218 76 210 46 204 60 165
Polygon -1 true false 75 45 83 77 71 103 86 114 166 78 135 60
Polygon -7500403 true true 30 136 151 77 226 81 280 119 292 146 292 160 287 170 270 195 195 210 151 212 30 166
Circle -16777216 true false 215 106 30

flag
false
0
Rectangle -7500403 true true 60 15 75 300
Polygon -7500403 true true 90 150 270 90 90 30
Line -7500403 true 75 135 90 135
Line -7500403 true 75 45 90 45

flower
false
0
Polygon -10899396 true false 135 120 165 165 180 210 180 240 150 300 165 300 195 240 195 195 165 135
Circle -7500403 true true 85 132 38
Circle -7500403 true true 130 147 38
Circle -7500403 true true 192 85 38
Circle -7500403 true true 85 40 38
Circle -7500403 true true 177 40 38
Circle -7500403 true true 177 132 38
Circle -7500403 true true 70 85 38
Circle -7500403 true true 130 25 38
Circle -7500403 true true 96 51 108
Circle -16777216 true false 113 68 74
Polygon -10899396 true false 189 233 219 188 249 173 279 188 234 218
Polygon -10899396 true false 180 255 150 210 105 210 75 240 135 240

house
false
0
Rectangle -7500403 true true 45 120 255 285
Rectangle -16777216 true false 120 210 180 285
Polygon -7500403 true true 15 120 150 15 285 120
Line -16777216 false 30 120 270 120

leaf
false
0
Polygon -7500403 true true 150 210 135 195 120 210 60 210 30 195 60 180 60 165 15 135 30 120 15 105 40 104 45 90 60 90 90 105 105 120 120 120 105 60 120 60 135 30 150 15 165 30 180 60 195 60 180 120 195 120 210 105 240 90 255 90 263 104 285 105 270 120 285 135 240 165 240 180 270 195 240 210 180 210 165 195
Polygon -7500403 true true 135 195 135 240 120 255 105 255 105 285 135 285 165 240 165 195

line
true
0
Line -7500403 true 150 0 150 300

line half
true
0
Line -7500403 true 150 0 150 150

pentagon
false
0
Polygon -7500403 true true 150 15 15 120 60 285 240 285 285 120

person
false
0
Circle -7500403 true true 110 5 80
Polygon -7500403 true true 105 90 120 195 90 285 105 300 135 300 150 225 165 300 195 300 210 285 180 195 195 90
Rectangle -7500403 true true 127 79 172 94
Polygon -7500403 true true 195 90 240 150 225 180 165 105
Polygon -7500403 true true 105 90 60 150 75 180 135 105
Circle -16777216 false false 108 3 84
Line -16777216 false 127 80 127 90
Polygon -16777216 false false 127 91 108 90 105 88 60 149 74 178 111 135 119 194 88 284 104 299 134 297 151 226 165 298 193 299 210 287 180 192 190 133 223 176 242 149 196 91 172 87 173 79 125 79

plant
false
0
Rectangle -7500403 true true 135 90 165 300
Polygon -7500403 true true 135 255 90 210 45 195 75 255 135 285
Polygon -7500403 true true 165 255 210 210 255 195 225 255 165 285
Polygon -7500403 true true 135 180 90 135 45 120 75 180 135 210
Polygon -7500403 true true 165 180 165 210 225 180 255 120 210 135
Polygon -7500403 true true 135 105 90 60 45 45 75 105 135 135
Polygon -7500403 true true 165 105 165 135 225 105 255 45 210 60
Polygon -7500403 true true 135 90 120 45 150 15 180 45 165 90

sheep
false
15
Circle -1 true true 203 65 88
Circle -1 true true 70 65 162
Circle -1 true true 150 105 120
Polygon -7500403 true false 218 120 240 165 255 165 278 120
Circle -7500403 true false 214 72 67
Rectangle -1 true true 164 223 179 298
Polygon -1 true true 45 285 30 285 30 240 15 195 45 210
Circle -1 true true 3 83 150
Rectangle -1 true true 65 221 80 296
Polygon -1 true true 195 285 210 285 210 240 240 210 195 210
Polygon -7500403 true false 276 85 285 105 302 99 294 83
Polygon -7500403 true false 219 85 210 105 193 99 201 83

square
false
0
Rectangle -7500403 true true 30 30 270 270

square 2
false
0
Rectangle -7500403 true true 30 30 270 270
Rectangle -16777216 true false 60 60 240 240

star
false
0
Polygon -7500403 true true 151 1 185 108 298 108 207 175 242 282 151 216 59 282 94 175 3 108 116 108

target
false
0
Circle -7500403 true true 0 0 300
Circle -16777216 true false 30 30 240
Circle -7500403 true true 60 60 180
Circle -16777216 true false 90 90 120
Circle -7500403 true true 120 120 60

tree
false
0
Circle -7500403 true true 118 3 94
Rectangle -6459832 true false 120 195 180 300
Circle -7500403 true true 65 21 108
Circle -7500403 true true 116 41 127
Circle -7500403 true true 45 90 120
Circle -7500403 true true 104 74 152

triangle
false
0
Polygon -7500403 true true 150 30 15 255 285 255

triangle 2
false
0
Polygon -7500403 true true 150 30 15 255 285 255
Polygon -16777216 true false 151 99 225 223 75 224

truck
false
0
Rectangle -7500403 true true 4 45 195 187
Polygon -7500403 true true 296 193 296 150 259 134 244 104 208 104 207 194
Rectangle -1 true false 195 60 195 105
Polygon -16777216 true false 238 112 252 141 219 141 218 112
Circle -16777216 true false 234 174 42
Rectangle -7500403 true true 181 185 214 194
Circle -16777216 true false 144 174 42
Circle -16777216 true false 24 174 42
Circle -7500403 false true 24 174 42
Circle -7500403 false true 144 174 42
Circle -7500403 false true 234 174 42

turtle
true
0
Polygon -10899396 true false 215 204 240 233 246 254 228 266 215 252 193 210
Polygon -10899396 true false 195 90 225 75 245 75 260 89 269 108 261 124 240 105 225 105 210 105
Polygon -10899396 true false 105 90 75 75 55 75 40 89 31 108 39 124 60 105 75 105 90 105
Polygon -10899396 true false 132 85 134 64 107 51 108 17 150 2 192 18 192 52 169 65 172 87
Polygon -10899396 true false 85 204 60 233 54 254 72 266 85 252 107 210
Polygon -7500403 true true 119 75 179 75 209 101 224 135 220 225 175 261 128 261 81 224 74 135 88 99

wheel
false
0
Circle -7500403 true true 3 3 294
Circle -16777216 true false 30 30 240
Line -7500403 true 150 285 150 15
Line -7500403 true 15 150 285 150
Circle -7500403 true true 120 120 60
Line -7500403 true 216 40 79 269
Line -7500403 true 40 84 269 221
Line -7500403 true 40 216 269 79
Line -7500403 true 84 40 221 269

wolf
false
0
Polygon -16777216 true false 253 133 245 131 245 133
Polygon -7500403 true true 2 194 13 197 30 191 38 193 38 205 20 226 20 257 27 265 38 266 40 260 31 253 31 230 60 206 68 198 75 209 66 228 65 243 82 261 84 268 100 267 103 261 77 239 79 231 100 207 98 196 119 201 143 202 160 195 166 210 172 213 173 238 167 251 160 248 154 265 169 264 178 247 186 240 198 260 200 271 217 271 219 262 207 258 195 230 192 198 210 184 227 164 242 144 259 145 284 151 277 141 293 140 299 134 297 127 273 119 270 105
Polygon -7500403 true true -1 195 14 180 36 166 40 153 53 140 82 131 134 133 159 126 188 115 227 108 236 102 238 98 268 86 269 92 281 87 269 103 269 113

x
false
0
Polygon -7500403 true true 270 75 225 30 30 225 75 270
Polygon -7500403 true true 30 75 75 30 270 225 225 270
@#$#@#$#@
NetLogo 6.0.1
@#$#@#$#@
@#$#@#$#@
@#$#@#$#@
<experiments>
  <experiment name="results 100k ticks 1 run each" repetitions="1" runMetricsEveryStep="true">
    <setup>setup</setup>
    <go>go</go>
    <final>exportshit</final>
    <exitCondition>ticks = runfor</exitCondition>
    <steppedValueSet variable="AmountOfClocks" first="0" step="1" last="10"/>
    <steppedValueSet variable="ClockPower" first="2" step="0.5" last="4"/>
    <enumeratedValueSet variable="SpawnPercentage">
      <value value="85"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="ClockSpeed">
      <value value="0.7"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="runfor">
      <value value="100000"/>
    </enumeratedValueSet>
  </experiment>
  <experiment name="results 100k ticks 4 run each 0 and 10 clocks power 4" repetitions="1" runMetricsEveryStep="true">
    <setup>setup</setup>
    <go>go</go>
    <final>exportshit</final>
    <exitCondition>ticks = runfor</exitCondition>
    <enumeratedValueSet variable="AmountOfClocks">
      <value value="0"/>
      <value value="10"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="ClockPower">
      <value value="4"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="SpawnPercentage">
      <value value="85"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="ClockSpeed">
      <value value="0.7"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="runfor">
      <value value="100000"/>
    </enumeratedValueSet>
  </experiment>
  <experiment name="results 100k ticks 2 run each 11-15" repetitions="2" runMetricsEveryStep="true">
    <setup>setup</setup>
    <go>go</go>
    <final>exportshit</final>
    <exitCondition>ticks = runfor</exitCondition>
    <steppedValueSet variable="AmountOfClocks" first="11" step="1" last="15"/>
    <steppedValueSet variable="ClockPower" first="2" step="0.5" last="4"/>
    <enumeratedValueSet variable="SpawnPercentage">
      <value value="85"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="ClockSpeed">
      <value value="0.7"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="runfor">
      <value value="100000"/>
    </enumeratedValueSet>
  </experiment>
  <experiment name="results 100k ticks 2 run each 11-15 power 4" repetitions="2" runMetricsEveryStep="true">
    <setup>setup</setup>
    <go>go</go>
    <final>exportshit</final>
    <exitCondition>ticks = runfor</exitCondition>
    <steppedValueSet variable="AmountOfClocks" first="11" step="1" last="15"/>
    <enumeratedValueSet variable="ClockPower">
      <value value="4"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="SpawnPercentage">
      <value value="85"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="ClockSpeed">
      <value value="0.7"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="runfor">
      <value value="100000"/>
    </enumeratedValueSet>
  </experiment>
</experiments>
@#$#@#$#@
@#$#@#$#@
default
0.0
-0.2 0 0.0 1.0
0.0 1 1.0 0.0
0.2 0 0.0 1.0
link direction
true
0
Line -7500403 true 150 150 90 180
Line -7500403 true 150 150 210 180
@#$#@#$#@
0
@#$#@#$#@
